class CollisionEngine extends Object {
	
	static int type;
	
	CollisionEngine(int type) {
		CollisionEngine.type=type;
	}
	
	public static void setType(int type) {
		
		CollisionEngine.type=type;
	}
	
	public static Draw check(Draw first,Draw second) {
		
		if(!first.isReal || !second.isReal)
			return null;
		if(type==CoreConstant.COLLISIONENGINE_BOUNDINGSPHERE) {
			return(checkBySphere(first,second));
		}else if(type==CoreConstant.COLLISIONENGINE_BOUNDINGBOX) {
			return(checkByBoundingBox(first,second));
		}else if(type==CoreConstant.COLLISIONENGINE_BYITERATION) {
			return(checkByConvexHull(first,second));
		}else if(type==CoreConstant.COLLISIONENGINE_ANALITYC) {
			return(checkByConvexHull(first,second));
		}
		return null;
	}
	
	public static Draw checkBySphere(Draw draw1,Draw draw2) {
		
		double[] baricenter1,baricenter2,farest1,farest2,origin=null,normal=null,plane,center={0,0,0,0},tmpVertex=null,translate1,translate2,base1,base2;
		double radius1,radius2,distance,distance1=0,distance2,magnitudo,height=0,z,t,cos=0,sen=0,tmp;
		Draw returnValue=null;
		int[] neighbour=null;
		
		baricenter1=Geometry.getBaricenter(draw1);
		baricenter2=Geometry.getBaricenter(draw2);
		farest1=draw1.getVertex(Geometry.findRealFarest(draw1,baricenter1)); // errore
		farest2=draw2.getVertex(Geometry.findRealFarest(draw2,baricenter2)); //errore il metodo e bidimensionale
		Geometry.setTransform(draw1);
		baricenter1=Geometry.getTransformedVertex(baricenter1);
		farest1=Geometry.getTransformedVertex(farest1);
		Geometry.setTransform(draw2);
		baricenter2=Geometry.getTransformedVertex(baricenter2);
		farest2=Geometry.getTransformedVertex(farest2);
		radius1=Geometry.distance(baricenter1,farest1);
		radius2=Geometry.distance(baricenter2,farest2);
		/*translate1=draw1.getTranslate();
		translate2=draw2.getTranslate();
		for(int i=0;i<translate1.length;i++) {
			baricenter1[i]+=translate1[i];
			baricenter2[i]+=translate2[i];
		}*/
		distance=Geometry.distance(baricenter1,baricenter2);
		if(radius1+radius2>distance) {
			distance2=(Math.pow(radius2,2.0)-Math.pow(radius1,2.0)+Math.pow(distance,2.0))/(2*distance);
			distance1=distance-distance2;
			t=distance1/distance;
			origin=new double[baricenter1.length];
			normal=new double[baricenter1.length];
			for(int i=0;i<origin.length;i++) {
				origin[i]=baricenter1[i]*t+baricenter2[i]*(1-t);
				normal[i]=-baricenter1[i]+origin[i];
			}
			magnitudo=Geometry.getMagnitudo(normal);
			for(int i=0;i<origin.length;i++)
				normal[i]=normal[i]/magnitudo;
			
			
			if(baricenter1[2]!=baricenter2[2]){
				z=(-normal[0]-normal[1])/normal[2];
				base1=new double[4];
				base1[0]=1;
				base1[1]=1;
				base1[2]=z;
				base1[3]=1;
			}else{
				z=(-normal[1]-normal[2])/normal[0];
				base1=new double[4];
				base1[0]=z;
				base1[1]=1;
				base1[2]=1;
				base1[3]=1;
			}
			magnitudo=Geometry.getMagnitudo(base1);
			for(int i=0;i<base1.length;i++)
				base1[i]=base1[i]/magnitudo;
			base2=Geometry.cross(normal,base1);
			origin[origin.length-1]=1.0;
			normal[normal.length-1]=0.0;
			
			
			
			height=Math.sqrt(Math.pow(radius1,2.0)-Math.pow(distance1,2.0));
			returnValue=new Draw();
			neighbour=new int[1];
			tmpVertex=new double[4];
			sen=Math.asin(distance1/radius1);
			for(int j=0;j<CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER;j++)
				for(int i=0;i<CoreConstant.COLLISIONENGINE_COLLISIONSPHERE;i++) {
					for(int k=0;k<base1.length-1;k++) {
						tmp=baricenter1[k];
						tmp=tmp+radius1*Math.cos(sen+(((Math.PI/2-sen)*(double)j/CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER)))*Math.sin(2*Math.PI*((double)i/CoreConstant.COLLISIONENGINE_COLLISIONSPHERE))*base1[k];
						tmp=tmp+radius1*Math.cos(sen+(((Math.PI/2-sen)*(double)j/CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER)))*Math.cos(2*Math.PI*((double)i/CoreConstant.COLLISIONENGINE_COLLISIONSPHERE))*base2[k];
						tmp=tmp+radius1*Math.sin(sen+(((Math.PI/2-sen)*(double)j/CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER)))*normal[k];
						tmpVertex[k]=tmp;
					}
					tmpVertex[3]=1.0;
					if(neighbour!=null && neighbour.length!=4)
						neighbour=new int[2];
					neighbour[0]=((i+1)%CoreConstant.COLLISIONENGINE_COLLISIONSPHERE)+(j*CoreConstant.COLLISIONENGINE_COLLISIONSPHERE);
					neighbour[1]=((i-1+CoreConstant.COLLISIONENGINE_COLLISIONSPHERE)%CoreConstant.COLLISIONENGINE_COLLISIONSPHERE)+(j*CoreConstant.COLLISIONENGINE_COLLISIONSPHERE);
					returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));
				}
			
			sen=Math.asin(distance2/radius2);
			for(int j=0;j<CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER;j++)
				for(int i=0;i<CoreConstant.COLLISIONENGINE_COLLISIONSPHERE;i++) {
					for(int k=0;k<base1.length-1;k++) {
						tmp=baricenter2[k];
						tmp=tmp+radius2*Math.cos(sen+(((Math.PI/2-sen)*(double)j/CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER)))*Math.sin(2*Math.PI*((double)i/CoreConstant.COLLISIONENGINE_COLLISIONSPHERE))*base1[k];
						tmp=tmp+radius2*Math.cos(sen+(((Math.PI/2-sen)*(double)j/CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER)))*Math.cos(2*Math.PI*((double)i/CoreConstant.COLLISIONENGINE_COLLISIONSPHERE))*base2[k];
						tmp=tmp-radius2*Math.sin(sen+(((Math.PI/2-sen)*(double)j/CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER)))*normal[k];
						tmpVertex[k]=tmp;
					}
					tmpVertex[3]=1.0;
					if(neighbour!=null && neighbour.length!=4)
						neighbour=new int[2];
					neighbour[0]=CoreConstant.COLLISIONENGINE_COLLISIONSPHERE*CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER+((i+1)%CoreConstant.COLLISIONENGINE_COLLISIONSPHERE)+(j*CoreConstant.COLLISIONENGINE_COLLISIONSPHERE);
					neighbour[1]=CoreConstant.COLLISIONENGINE_COLLISIONSPHERE*CoreConstant.COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER+((i-1+CoreConstant.COLLISIONENGINE_COLLISIONSPHERE)%CoreConstant.COLLISIONENGINE_COLLISIONSPHERE)+(j*CoreConstant.COLLISIONENGINE_COLLISIONSPHERE);
					returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));
				}
		}
		if(returnValue!=null){
			returnValue.setColor(CoreConstant.COLLISIONENGINE_COLOR);
			returnValue.isReal=false;
		}
		return returnValue;
	}
	
	public static Draw checkByBoundingBox(Draw draw1,Draw draw2){
		
		double[] minmax1=new double[6],minmax2=new double[6],bounding=new double[6];
		double[] tmpVertex,vertexValue;
		int[] neighbour;
		Draw returnValue=null;
		boolean x,y,z;
		minmax1[0]=Double.POSITIVE_INFINITY;
		minmax1[1]=Double.NEGATIVE_INFINITY;
		minmax1[2]=Double.POSITIVE_INFINITY;
		minmax1[3]=Double.NEGATIVE_INFINITY;
		minmax1[4]=Double.POSITIVE_INFINITY;
		minmax1[5]=Double.NEGATIVE_INFINITY;
		minmax2[0]=Double.POSITIVE_INFINITY;
		minmax2[1]=Double.NEGATIVE_INFINITY;
		minmax2[2]=Double.POSITIVE_INFINITY;
		minmax2[3]=Double.NEGATIVE_INFINITY;
		minmax2[4]=Double.POSITIVE_INFINITY;
		minmax2[5]=Double.NEGATIVE_INFINITY;
		
		Geometry.setTransform(draw1);
		for(int i=0;i<draw1.size();i++){
			vertexValue=draw1.getVertex(i);
			tmpVertex=Geometry.getTransformedVertex(vertexValue);
			tmpVertex=Geometry.makeOmogenous(tmpVertex);
			if(tmpVertex[0]<minmax1[0])
				minmax1[0]=tmpVertex[0];
			else if(tmpVertex[0]>minmax1[1])
				minmax1[1]=tmpVertex[0];
			if(tmpVertex[1]<minmax1[2])
				minmax1[2]=tmpVertex[1];
			else if(tmpVertex[1]>minmax1[3])
				minmax1[3]=tmpVertex[1];
			if(tmpVertex[2]<minmax1[4])
				minmax1[4]=tmpVertex[2];
			else if(tmpVertex[2]>minmax1[5])
				minmax1[5]=tmpVertex[2];
		}
//		for(int i=0;i<minmax1.length;i++)
//			System.out.println("minmax1["+i+"] "+minmax1[i]);
		Geometry.setTransform(draw2);
		for(int i=0;i<draw2.size();i++){
			vertexValue=draw2.getVertex(i);
			tmpVertex=Geometry.getTransformedVertex(vertexValue);
			tmpVertex=Geometry.makeOmogenous(tmpVertex);
			if(tmpVertex[0]<minmax2[0])
				minmax2[0]=tmpVertex[0];
			else if(tmpVertex[0]>minmax2[1])
				minmax2[1]=tmpVertex[0];
			if(tmpVertex[1]<minmax2[2])
				minmax2[2]=tmpVertex[1];
			else if(tmpVertex[1]>minmax2[3])
				minmax2[3]=tmpVertex[1];
			if(tmpVertex[2]<minmax2[4])
				minmax2[4]=tmpVertex[2];
			else if(tmpVertex[2]>minmax2[5])
				minmax2[5]=tmpVertex[2];
		}
//		for(int i=0;i<minmax2.length;i++)
//			System.out.println("minmax2["+i+"] "+minmax2[i]);
		x=((minmax1[0]<=minmax2[0] && minmax1[1]>=minmax2[0]) || (minmax1[0]<=minmax2[1] && minmax1[1]>=minmax2[1])) || (minmax1[0]<minmax2[0] && minmax1[1]>minmax2[1]) || (minmax1[0]>minmax2[0] && minmax1[1]<minmax2[1]);
		y=((minmax1[2]<=minmax2[2] && minmax1[3]>=minmax2[2]) || (minmax1[2]<=minmax2[3] && minmax1[3]>=minmax2[3])) || (minmax1[2]<minmax2[2] && minmax1[3]>minmax2[3]) || (minmax1[2]>minmax2[2] && minmax1[3]<minmax2[3]);
		z=((minmax1[4]<=minmax2[4] && minmax1[5]>=minmax2[4]) || (minmax1[4]<=minmax2[5] && minmax1[5]>=minmax2[5])) || (minmax1[4]<minmax2[4] && minmax1[5]>minmax2[5]) || (minmax1[4]>minmax2[4] && minmax1[5]<minmax2[5]);
//		System.out.println("x " +x+" y " +y+" z "+z);
		if(x && y && z ){
//			System.out.println("in");
			returnValue=new Draw();
			tmpVertex=new double[4];
			neighbour=new int[3];
			if(minmax1[0]<minmax2[0])
				bounding[0]=minmax2[0];
			else
				bounding[0]=minmax1[0];
			if(minmax1[1]<minmax2[1])
				bounding[1]=minmax1[1];
			else
				bounding[1]=minmax2[1];
			if(minmax1[2]<minmax2[2])
				bounding[2]=minmax2[2];
			else
				bounding[2]=minmax1[2];
			if(minmax1[3]<minmax2[3])
				bounding[3]=minmax1[3];
			else
				bounding[3]=minmax2[3];
			if(minmax1[4]<minmax2[4])
				bounding[4]=minmax2[4];
			else
				bounding[4]=minmax1[4];
			if(minmax1[5]<minmax2[5])
				bounding[5]=minmax1[5];
			else
				bounding[5]=minmax2[5];
//			for(int j=0;j<bounding.length;j++)
//				System.out.println("bounding["+j+"] " +bounding[j]);
			tmpVertex[0]=bounding[0];
			tmpVertex[1]=bounding[2];
			tmpVertex[2]=bounding[4];
			tmpVertex[3]=1.0;
			neighbour[0]=1;
			neighbour[1]=2;
			neighbour[2]=3;
			returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));//0
			tmpVertex[0]=bounding[1];
			tmpVertex[1]=bounding[2];
			tmpVertex[2]=bounding[4];
			tmpVertex[3]=1.0;
			neighbour[0]=0;
			neighbour[1]=4;
			neighbour[2]=5;
			returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));//1
			tmpVertex[0]=bounding[0];
			tmpVertex[1]=bounding[3];
			tmpVertex[2]=bounding[4];
			tmpVertex[3]=1.0;
			neighbour[0]=0;
			neighbour[1]=4;
			neighbour[2]=6;
			returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));//2
			tmpVertex[0]=bounding[0];
			tmpVertex[1]=bounding[2];
			tmpVertex[2]=bounding[5];
			tmpVertex[3]=1.0;
			neighbour[0]=0;
			neighbour[1]=6;
			neighbour[2]=5;
			returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));//3
			tmpVertex[0]=bounding[1];
			tmpVertex[1]=bounding[3];
			tmpVertex[2]=bounding[4];
			tmpVertex[3]=1.0;
			neighbour[0]=1;
			neighbour[1]=2;
			neighbour[2]=7;
			returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));//4
			tmpVertex[0]=bounding[1];
			tmpVertex[1]=bounding[2];
			tmpVertex[2]=bounding[5];
			tmpVertex[3]=1.0;
			neighbour[0]=1;
			neighbour[1]=7;
			neighbour[2]=3;
			returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));//5
			tmpVertex[0]=bounding[0];
			tmpVertex[1]=bounding[3];
			tmpVertex[2]=bounding[5];
			tmpVertex[3]=1.0;
			neighbour[0]=2;
			neighbour[1]=3;
			neighbour[2]=7;
			returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));//6
			tmpVertex[0]=bounding[1];
			tmpVertex[1]=bounding[3];
			tmpVertex[2]=bounding[5];
			tmpVertex[3]=1.0;
			neighbour[0]=6;
			neighbour[1]=5;
			neighbour[2]=4;
			returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));//7
			returnValue.setColor(CoreConstant.COLLISIONENGINE_COLOR);
			returnValue.isReal=false;
//			System.out.println(returnValue);
		}
//		System.out.println(returnValue);
		return returnValue;
	}
	
	public static Draw checkByConvexHull(Draw first,Draw second){
		
		Draw returnValue;
		DrawPlus d1,d2;
		double[] baricenter1,baricenter2,base1,base2,tmpVertex,plane;
		double distance,min1,min2,numerator,denominator,t,t1;
		int farest1,farest2,nearest1,nearest2,index,intersectionCounter1,intersectionCounter2,index1,index2,ceCounter1,ceCounter2;
		double[][] normals1,origins1,tmpOrigin,normals2,origins2,intersection1,intersection2,line,point,vectorPP,vectorVP;
		double[][][] criticalEdge1,criticalEdge2;
		int[][] vertex1,vertex2;
		int[] tmpNeighbour,buffer,remapping,tmpBuffer,inner1,outer1,inner2,outer2,linked,tmpFace;
		int dimesion,bufferFinish,innerCounter1,outerCounter1,innerCounter2,outerCounter2,bufferCounter,linkedCounter;
		boolean[] processed,expand;
		boolean expansion=true;
		
		baricenter1=Geometry.getBaricenter(first);
		baricenter2=Geometry.getBaricenter(second);
		Geometry.setTransform(first);
		baricenter1=Geometry.getTransformedVertex(baricenter1);
		Geometry.setTransform(second);
		baricenter2=Geometry.getTransformedVertex(baricenter2);
		farest1=Geometry.findRealFarest(first,baricenter1);
		farest2=Geometry.findRealFarest(second,baricenter2);
		if(Geometry.distance(baricenter1,baricenter2)>(Geometry.distance(baricenter1,first.getVertex(farest1))+Geometry.distance(baricenter2,second.getVertex(farest2))))
			return null;
		returnValue=new Draw();
		d1=getConvexHull(first);
		d2=getConvexHull(second);
		
		Geometry.setTransform(d1);
		baricenter1=Geometry.getBaricenter(d1);
		baricenter1=Geometry.getTransformedVertex(baricenter1);
		nearest2=Geometry.findRealNearest(d2,baricenter1);
		
		Geometry.setTransform(d2);
		baricenter2=Geometry.getBaricenter(d2);
		baricenter2=Geometry.getTransformedVertex(baricenter2);
		nearest1=Geometry.findRealNearest(d1,baricenter2);
		
		normals1=d1.getNormals();
		origins1=d1.getOrigins();
		vertex1=d1.getFaces();
		
		normals2=d2.getNormals();
		origins2=d2.getOrigins();
		vertex2=d2.getFaces();
		
		Geometry.setTransform(d1);
		for(int i=0;i<origins1.length;i++){
			origins1[i]=Geometry.getTransformedVertex(origins1[i]);
			normals1[i]=Geometry.valueProduct(normals1[i],10);
			normals1[i]=Geometry.getTransformedVertex(normals1[i]);
			normals1[i]=Geometry.normalize(normals1[i]);
		}
		Geometry.setTransform(d2);
		for(int i=0;i<origins2.length;i++){
			origins2[i]=Geometry.getTransformedVertex(origins2[i]);
			normals2[i]=Geometry.valueProduct(normals2[i],10);
			normals2[i]=Geometry.getTransformedVertex(normals2[i]);
			normals2[i]=Geometry.normalize(normals2[i]);
		}
		
		intersection1=new double[4*d1.size()][4];
		intersectionCounter1=0;
		
		intersectionCounter2=0;
		intersection2=new double[4*d2.size()][4]; // was outerX.length
		
		buffer=new int[d2.size()];
		tmpBuffer=new int[d2.size()];
		bufferCounter=0;
		
		bufferFinish=1;
		buffer[0]=nearest2;
		processed=new boolean[d2.size()];
		inner2=new int[d2.size()];
		outer2=new int[d2.size()];
		for(int i=0;i<inner2.length;i++){
			inner2[i]=-1;
			outer2[i]=-1;
		}
		expand=new boolean[d2.size()];
		expansion=true;
		innerCounter2=0;
		outerCounter2=0;
//		System.out.println("trovo i punti per 2");
		index2=d2.getIndex();
		index1=d1.getIndex();

		
		//trasformare lengthorigini
		//per tutti le faccie
		//per tutti i punti da controllare ora
		//	controlla se i punti nel buffer sono sotto la faccia
		//		se sono sotto inserisci il punto nel inner a meno che gia presenti
		//		se no nel outer a meno che gia inseriti
		//per tutti i punti in inner e in buffer
		//	espandili(mettere i  vicini e togliere loro) a meno che gia controllati
		//se l'esapnsione e nulla hai trovato tutti i punti in inner e in outer
		Geometry.setTransform(d2);
		while(expansion){
			for (int i=0;i<expand.length;i++)
				expand[i]=true;
			for(int i=0;i<tmpBuffer.length;i++)
				tmpBuffer[i]=-1;
			bufferCounter=0;
//			for(int i=0;i<bufferFinish;i++)
//				System.out.println("buffer2["+i+"] " +buffer[i]);

			for (int i=0;i<index1;i++)
				for(int j=0;j<bufferFinish;j++)
					if(expand[buffer[j]]){
						tmpVertex=d2.getVertex(buffer[j]);
						tmpVertex=Geometry.getTransformedVertex(tmpVertex);
						tmpVertex=Geometry.pointToVector(origins1[i],tmpVertex);
						distance=Geometry.dotProduct(tmpVertex,normals1[i]);
//						System.out.println("distanza " +buffer[j] +" e faccia " +i +" :"+distance);
						if(distance<0)
							if(notIn(buffer[j],outer2)){
								expand[buffer[j]]=false;
								outer2[outerCounter2++]=buffer[j];
//								System.out.println("non espando: "+buffer[j]+ " in " +(outerCounter2-1));
							}else
								expand[buffer[j]]=false;
					}
			for(int i=0;i<bufferFinish;i++){
				processed[buffer[i]]=true;
				if(expand[buffer[i]]){
					tmpNeighbour=d2.getNeighbours(buffer[i]);
					for(int j=0;j<tmpNeighbour.length;j++)
						if(!processed[tmpNeighbour[j]] && notIn(tmpNeighbour[j],tmpBuffer))
							tmpBuffer[bufferCounter++]=tmpNeighbour[j];
					if(notIn(buffer[i],inner2)){
//						System.out.println("metto "+buffer[i]+" in inner2");
						inner2[innerCounter2++]=buffer[i];
					}
				}
				
			}
			if(bufferCounter!=0){
				for(int i=0;i<bufferCounter;i++)
					buffer[i]=tmpBuffer[i];
				bufferFinish=bufferCounter;
				bufferCounter=0;
			}else
				expansion=false;

		}
		//inizio trvo punti per 1 fig

		
		
		processed=new boolean[d1.size()];
		inner1=new int[d1.size()];
		outer1=new int[d1.size()];
		for(int i=0;i<inner1.length;i++){
			inner1[i]=-1;
			outer1[i]=-1;
		}
//		System.out.println(nearest1);  giusto
		buffer=new int[d1.size()];
		buffer[0]=nearest1;
		bufferFinish=1;
		innerCounter1=0;
		outerCounter1=0;
		expansion=true;
		expand=new boolean[d1.size()];
		tmpBuffer=new int[d1.size()];
		bufferCounter=0;
//		System.out.println("trovo i punti per 1");
		Geometry.setTransform(d1);
		
		while(expansion){
			for (int i=0;i<expand.length;i++)
				expand[i]=true;
			for(int i=0;i<tmpBuffer.length;i++)
				tmpBuffer[i]=-1;
			bufferCounter=0;
//			for (int i=0;i<bufferFinish;i++)
//				System.out.println("buffer1["+i+"] " +buffer[i]);
//			System.out.println("");
			for (int i=0;i<index2;i++)
				for(int j=0;j<bufferFinish;j++)
					if(expand[buffer[j]]){
						tmpVertex=d1.getVertex(buffer[j]);
						tmpVertex=Geometry.getTransformedVertex(tmpVertex);
						tmpVertex=Geometry.pointToVector(origins2[i],tmpVertex);
						distance=Geometry.dotProduct(tmpVertex,normals2[i]);
//						System.out.println("distanza " +buffer[j] +" e faccia " +i +" :"+distance);
						if(distance<0)
							if(notIn(buffer[j],outer1)){
								expand[buffer[j]]=false;
								outer1[outerCounter1++]=buffer[j];
//								System.out.println("non espando: "+buffer[j]+ " in " +(outerCounter2-1));
							}else
								expand[buffer[j]]=false;
					}
			for(int i=0;i<bufferFinish;i++){
				processed[buffer[i]]=true;
				if(expand[buffer[i]]){
					tmpNeighbour=d1.getNeighbours(buffer[i]);
/*					System.out.print("vicini :");
					for(int m=0;m<tmpNeighbour.length;m++)
						System.out.print(tmpNeighbour[m] +" ");
					System.out.println();*/
					for(int j=0;j<tmpNeighbour.length;j++)
						if(!processed[tmpNeighbour[j]] && notIn(tmpNeighbour[j],tmpBuffer))
							tmpBuffer[bufferCounter++]=tmpNeighbour[j];
					if(notIn(buffer[i],inner1)){
//						System.out.println("metto "+buffer[i]+" in inner1");
						inner1[innerCounter1++]=buffer[i];
					}
				}
				
			}
			if(bufferCounter!=0){
				for(int i=0;i<bufferCounter;i++)
					buffer[i]=tmpBuffer[i];
				bufferFinish=bufferCounter;
				bufferCounter=0;
			}else
				expansion=false;
//			for(int i=0;i<bufferCounter;i++)
//				System.out.println("buffer["+i+"] " +buffer[i]);
		}
		if(innerCounter1==0 && innerCounter2==0)
			return null;
		/*for(int i=0;i<innerCounter1;i++)
			System.out.println("inner1["+i+"] " +inner1[i]);
		for(int i=0;i<outerCounter1;i++)
			System.out.println("outer1["+ i+"] " +outer1[i]);
		for(int i=0;i<innerCounter2;i++)
			System.out.println("inner2["+i+"] " +inner2[i]);
		for(int i=0;i<outerCounter2;i++)
			System.out.println("outer2["+ i+"] " +outer2[i]);*/
		criticalEdge1=new double[d1.size()*4][2][];
		criticalEdge2=new double[d2.size()*4][2][];
		ceCounter2=0;
		ceCounter1=0;
		if(innerCounter1==0){ 
			Geometry.setTransform(d2);
			for(int i=0;i<innerCounter2;i++){
				tmpNeighbour=d2.getNeighbours(inner2[i]);
				for(int j=0;j<outerCounter2;j++)
					if(isIn(outer2[j],tmpNeighbour)){
						criticalEdge2[ceCounter2][0]=Geometry.getTransformedVertex(d2.getVertex(inner2[i]));;
						criticalEdge2[ceCounter2++][1]=Geometry.getTransformedVertex(d2.getVertex(outer2[j]));;
					}
			}
			Geometry.setTransform(d1);
			for(int i=0;i<index1;i++)
				for(int j=0;j<ceCounter2;j++){
					intersection1[intersectionCounter1]=Geometry.intersectionPE(normals1[i],origins1[i],criticalEdge2[j][0],criticalEdge2[j][1]);
					if(intersection1[intersectionCounter1]!=null && Geometry.belongsAP(Geometry.getTransformedVertex(d1.getVertex(vertex1[i][0])),Geometry.getTransformedVertex(d1.getVertex(vertex1[i][1])),Geometry.getTransformedVertex(d1.getVertex(vertex1[i][2])),intersection1[intersectionCounter1]))
						intersectionCounter1++;
				}
		}
		if(innerCounter2==0){ //forse faccia? controlliamole
			Geometry.setTransform(d1);
			for(int i=0;i<innerCounter1;i++){
				tmpNeighbour=d1.getNeighbours(inner1[i]);
				for(int j=0;j<outerCounter1;j++)
					if(isIn(outer1[j],tmpNeighbour)){
						criticalEdge1[ceCounter1][0]=Geometry.getTransformedVertex(d1.getVertex(inner1[i]));
						criticalEdge1[ceCounter1++][1]=Geometry.getTransformedVertex(d1.getVertex(outer1[j]));
					}
			}
			Geometry.setTransform(d2);
			for(int i=0;i<index2;i++)
				for(int j=0;j<ceCounter1;j++){
					intersection2[intersectionCounter2]=Geometry.intersectionPE(normals2[i],origins2[i],criticalEdge1[j][0],criticalEdge1[j][1]);
					if(intersection2[intersectionCounter2]!=null && Geometry.belongsAP(Geometry.getTransformedVertex(d2.getVertex(vertex2[i][0])),Geometry.getTransformedVertex(d2.getVertex(vertex2[i][1])),Geometry.getTransformedVertex(d2.getVertex(vertex2[i][2])),intersection2[intersectionCounter2]))
						intersectionCounter2++;
				}
		}
		linked=new int[d1.size()];
		line=new double[2][];
		plane=new double[4];
		index=-1;
		Geometry.setTransform(d1);

		tmpVertex=new double[4];
		point=new double[3][];
		if(innerCounter1>0)
			for(int i=0;i<outerCounter1;i++){
				tmpNeighbour=d1.getNeighbours(outer1[i]);
				linkedCounter=0;
				for(int j=0;j<tmpNeighbour.length;j++)
					if(isIn(tmpNeighbour[j],inner1))
						linked[linkedCounter++]=tmpNeighbour[j];
//				System.out.println("linkedCounter "+linkedCounter);
				for(int j=0;j<linkedCounter;j++){
//					System.out.println("calcolo intersezioni per nodi: " +outer1[i] +" e " +linked[j]);
					line[0]=d1.getVertex(outer1[i]);
					line[1]=d1.getVertex(linked[j]);
					line[0]=Geometry.getTransformedVertex(line[0]);
					line[1]=Geometry.getTransformedVertex(line[1]);
					min1=Double.POSITIVE_INFINITY;
					vectorPP=new double[2][4];
					vectorVP=new double[1][4];
					index=-1;
					t1=0;
					for(int k=0;k<origins2.length;k++){
	//					System.out.println("indice della faccia intersecante " +k);
						plane[0]=normals2[k][0];
						plane[1]=normals2[k][1];
						plane[2]=normals2[k][2];
						plane[3]=-(plane[0]*origins2[k][0]+plane[1]*origins2[k][1]+plane[2]*origins2[k][2]);
						tmpFace=vertex2[k];
	/*					for (int m=0;m<plane.length;m++)
							System.out.print("plane["+m+"] " +plane[m] +" ");
						System.out.println();*/
						denominator=plane[0]*(line[1][0]-line[0][0])+plane[1]*(line[1][1]-line[0][1])+plane[2]*(line[1][2]-line[0][2]);
						numerator=plane[0]*line[1][0]+plane[1]*line[1][1]+plane[2]*line[1][2]+plane[3];
						t=numerator/denominator;
						if(t<=1 && t>=0){
								/*System.out.println("t " +t);
								for (int m=0;m<plane.length;m++)
									System.out.print("plane["+m+"] " +plane[m] +" ");
								System.out.println();
								for(int m=0;m<line[0].length;m++)
									System.out.print("line0["+m+"] " +line[0][m] +" ");
								System.out.println();
								for(int m=0;m<line[1].length;m++)
									System.out.print("line0["+m+"] " +line[1][m] +" ");
								System.out.println();*/
								tmpVertex[0]=line[1][0]-t*(line[1][0]-line[0][0]);
								tmpVertex[1]=line[1][1]-t*(line[1][1]-line[0][1]);
								tmpVertex[2]=line[1][2]-t*(line[1][2]-line[0][2]);
								tmpVertex[3]=1.0;
								point[0]=d2.getVertex(tmpFace[0]);
								point[1]=d2.getVertex(tmpFace[1]);
								point[2]=d2.getVertex(tmpFace[2]);
								Geometry.setTransform(d2);
								point[0]=Geometry.getTransformedVertex(point[0]);
								point[1]=Geometry.getTransformedVertex(point[1]);
								point[2]=Geometry.getTransformedVertex(point[2]);
								Geometry.setTransform(d1);
	//							System.out.println("ci entro?");
								/*for(int m=0;m<4;m++)
									System.out.println("point0["+m+"] " +point[0][m]);
								for(int m=0;m<4;m++)
									System.out.println("point1["+m+"] " +point[1][m]);
								for(int m=0;m<4;m++)
									System.out.println("point2["+m+"] " +point[2][m]);
								for(int m=0;m<4;m++)
									System.out.println("tmpVertex["+m+"] " +tmpVertex[m]);
								System.out.println("distance 0-1 " + Geometry.distance(point[0],point[1])+" distance 1-2 " +Geometry.distance(point[1],point[2])+ " distance 0-2 " +Geometry.distance(point[2],point[0]));
								System.out.println("distance 0-t " + Geometry.distance(point[0],tmpVertex)+ " distance 1-t " +Geometry.distance(point[1],tmpVertex) + " distance 2-t " +Geometry.distance(point[2],tmpVertex));*/
								vectorPP[0]=Geometry.pointToVector(point[1],point[0]);
								vectorPP[1]=Geometry.pointToVector(point[2],point[0]);
								vectorVP[0]=Geometry.pointToVector(tmpVertex,point[0]);
	/*							System.out.println("first stage");
								for(int m=0;m<3;m++)
									System.out.println("vectorPP0["+m+"] "+vectorPP[0][m]+"vectorPP1["+m+"] "+vectorPP[1][m]+"vectorVP0["+m+"] "+vectorVP[0][m]);
								System.out.println("cos PP0 VP0 " +Math.acos(Geometry.cos(vectorPP[0],vectorVP[0])) +" angle pp1 vp0 " +Math.acos(Geometry.cos(vectorPP[1],vectorVP[0]))+" angle pp0 pp1 " +Math.acos(Geometry.cos(vectorPP[0],vectorPP[1])));*/
								if(Math.acos(Geometry.cos(vectorPP[0],vectorVP[0]))<=Math.acos(Geometry.cos(vectorPP[0],vectorPP[1])) &&
								Math.acos(Geometry.cos(vectorPP[1],vectorVP[0]))<=Math.acos(Geometry.cos(vectorPP[0],vectorPP[1]))){
									vectorPP[0]=Geometry.pointToVector(point[0],point[1]);
									vectorPP[1]=Geometry.pointToVector(point[2],point[1]);
									vectorVP[0]=Geometry.pointToVector(tmpVertex,point[1]);
	/*								System.out.println("second stage");
									for(int m=0;m<3;m++)
									System.out.println("vectorPP0["+m+"] "+vectorPP[0][m]+"vectorPP1["+m+"] "+vectorPP[1][m]+"vectorVP0["+m+"] "+vectorVP[0][m]);
								System.out.println("cos PP0 VP0 " +Math.acos(Geometry.cos(vectorPP[0],vectorVP[0])) +" angle pp1 vp0 " +Math.acos(Geometry.cos(vectorPP[1],vectorVP[0]))+" angle pp0 pp1 " +Math.acos(Geometry.cos(vectorPP[0],vectorPP[1])));*/
									if(Math.acos(Geometry.cos(vectorPP[0],vectorVP[0]))<=Math.acos(Geometry.cos(vectorPP[0],vectorPP[1])) &&
									Math.acos(Geometry.cos(vectorPP[1],vectorVP[0]))<=Math.acos(Geometry.cos(vectorPP[0],vectorPP[1]))){
//										System.out.println("ci entro!");
										intersection1[intersectionCounter1][0]=tmpVertex[0];
										intersection1[intersectionCounter1][1]=tmpVertex[1];
										intersection1[intersectionCounter1][2]=tmpVertex[2];
										intersection1[intersectionCounter1++][3]=1.0;
									}
								}
						}
					}
				}
			}
		Geometry.setTransform(d2);
		tmpVertex=new double[4];
		if(innerCounter2>0)
			for(int i=0;i<outerCounter2;i++){
				tmpNeighbour=d2.getNeighbours(outer2[i]);
				linkedCounter=0;
				for(int j=0;j<tmpNeighbour.length;j++)
					if(isIn(tmpNeighbour[j],inner2))
						linked[linkedCounter++]=tmpNeighbour[j];
//				System.out.println("linkedCounter "+linkedCounter);
				for(int j=0;j<linkedCounter;j++){
//					System.out.println("calcolo intersezioni per nodi: " +outer2[i] +" e " +linked[j]);
					line[0]=d2.getVertex(outer2[i]);
					line[1]=d2.getVertex(linked[j]);
					line[0]=Geometry.getTransformedVertex(line[0]);
					line[1]=Geometry.getTransformedVertex(line[1]);
					min2=Double.POSITIVE_INFINITY;
					vectorPP=new double[2][4];
					vectorVP=new double[1][4];
					index=-1;
					t1=0;
					for(int k=0;k<origins1.length;k++){
	//					System.out.println("indice della faccia intersecante " +k);
						plane[0]=normals1[k][0];
						plane[1]=normals1[k][1];
						plane[2]=normals1[k][2];
						plane[3]=-(plane[0]*origins1[k][0]+plane[1]*origins1[k][1]+plane[2]*origins1[k][2]);
						tmpFace=vertex1[k];
	//				for (int m=0;m<plane.length;m++)
	//						System.out.print("plane["+m+"] " +plane[m] +" ");
	//					System.out.println();
						denominator=plane[0]*(line[1][0]-line[0][0])+plane[1]*(line[1][1]-line[0][1])+plane[2]*(line[1][2]-line[0][2]);
						numerator=plane[0]*line[1][0]+plane[1]*line[1][1]+plane[2]*line[1][2]+plane[3];
						t=numerator/denominator;
						if(t<=1 && t>=0){
	//							System.out.println("t " +t);
	//							for (int m=0;m<plane.length;m++)
	//								System.out.print("plane["+m+"] " +plane[m] +" ");
	//							System.out.println();
	//							for(int m=0;m<line[0].length;m++)
	//								System.out.print("line0["+m+"] " +line[0][m] +" ");
	//							System.out.println();
	//							for(int m=0;m<line[1].length;m++)
	//								System.out.print("line0["+m+"] " +line[1][m] +" ");
	//							System.out.println();
								tmpVertex[0]=line[1][0]-t*(line[1][0]-line[0][0]);
								tmpVertex[1]=line[1][1]-t*(line[1][1]-line[0][1]);
								tmpVertex[2]=line[1][2]-t*(line[1][2]-line[0][2]);
								tmpVertex[3]=1.0;
								point[0]=d1.getVertex(tmpFace[0]);
								point[1]=d1.getVertex(tmpFace[1]);
								point[2]=d1.getVertex(tmpFace[2]);
								Geometry.setTransform(d1);
								point[0]=Geometry.getTransformedVertex(point[0]);
								point[1]=Geometry.getTransformedVertex(point[1]);
								point[2]=Geometry.getTransformedVertex(point[2]);
								Geometry.setTransform(d2);
	//							System.out.println("ci entro?");
	//							/*for(int m=0;m<4;m++)
	//								System.out.println("point0["+m+"] " +point[0][m]);
	//							for(int m=0;m<4;m++)
	//								System.out.println("point1["+m+"] " +point[1][m]);
	//							for(int m=0;m<4;m++)
	//								System.out.println("point2["+m+"] " +point[2][m]);
	//							for(int m=0;m<4;m++)
	//								System.out.println("tmpVertex["+m+"] " +tmpVertex[m]);
	//							System.out.println("distance 0-1 " + Geometry.distance(point[0],point[1])+" distance 1-2 " +Geometry.distance(point[1],point[2])+ " distance 0-2 " +Geometry.distance(point[2],point[0]));
	//							System.out.println("distance 0-t " + Geometry.distance(point[0],tmpVertex)+ " distance 1-t " +Geometry.distance(point[1],tmpVertex) + " distance 2-t " +Geometry.distance(point[2],tmpVertex));
								vectorPP[0]=Geometry.pointToVector(point[1],point[0]);
								vectorPP[1]=Geometry.pointToVector(point[2],point[0]);
								vectorVP[0]=Geometry.pointToVector(tmpVertex,point[0]);
	/*							System.out.println("first stage");
								for(int m=0;m<3;m++)
									System.out.println("vectorPP0["+m+"] "+vectorPP[0][m]+"vectorPP1["+m+"] "+vectorPP[1][m]+"vectorVP0["+m+"] "+vectorVP[0][m]);
								System.out.println("cos PP0 VP0 " +Math.acos(Geometry.cos(vectorPP[0],vectorVP[0])) +" angle pp1 vp0 " +Math.acos(Geometry.cos(vectorPP[1],vectorVP[0]))+" angle pp0 pp1 " +Math.acos(Geometry.cos(vectorPP[0],vectorPP[1])));*/
								if(Math.acos(Geometry.cos(vectorPP[0],vectorVP[0]))<=Math.acos(Geometry.cos(vectorPP[0],vectorPP[1])) &&
								Math.acos(Geometry.cos(vectorPP[1],vectorVP[0]))<=Math.acos(Geometry.cos(vectorPP[0],vectorPP[1]))){
									vectorPP[0]=Geometry.pointToVector(point[0],point[1]);
									vectorPP[1]=Geometry.pointToVector(point[2],point[1]);
									vectorVP[0]=Geometry.pointToVector(tmpVertex,point[1]);
	/*								System.out.println("second stage");
									for(int m=0;m<3;m++)
									System.out.println("vectorPP0["+m+"] "+vectorPP[0][m]+"vectorPP1["+m+"] "+vectorPP[1][m]+"vectorVP0["+m+"] "+vectorVP[0][m]);
								System.out.println("cos PP0 VP0 " +Math.acos(Geometry.cos(vectorPP[0],vectorVP[0])) +" angle pp1 vp0 " +Math.acos(Geometry.cos(vectorPP[1],vectorVP[0]))+" angle pp0 pp1 " +Math.acos(Geometry.cos(vectorPP[0],vectorPP[1])));*/
									if(Math.acos(Geometry.cos(vectorPP[0],vectorVP[0]))<=Math.acos(Geometry.cos(vectorPP[0],vectorPP[1])) &&
									Math.acos(Geometry.cos(vectorPP[1],vectorVP[0]))<=Math.acos(Geometry.cos(vectorPP[0],vectorPP[1]))){
//										System.out.println("ci entro!");
										intersection2[intersectionCounter2][0]=tmpVertex[0];
										intersection2[intersectionCounter2][1]=tmpVertex[1];
										intersection2[intersectionCounter2][2]=tmpVertex[2];
										intersection2[intersectionCounter2++][3]=1.0;
									}
								}
						}
					}
				}
			}
		for(int i=0;i<intersectionCounter1;i++)
			for(int j=0;j<intersectionCounter2;j++)
				if(Geometry.isNearlyEqual(intersection1[i],intersection2[j]))
					intersection1[i]=intersection1[--intersectionCounter1];
		Geometry.setTransform(d1);
		tmpNeighbour=new int[1];
		for(int i=0;i<innerCounter1;i++){
			tmpVertex=Geometry.getTransformedVertex(d1.getVertex(inner1[i]));
			tmpNeighbour[0]=i;
			returnValue.addElement(tmpVertex,tmpNeighbour);
		}
		Geometry.setTransform(d2);
		for(int i=0;i<innerCounter2;i++){
			tmpVertex=Geometry.getTransformedVertex(d2.getVertex(inner2[i]));
			tmpNeighbour[0]=innerCounter1+i;
			returnValue.addElement(tmpVertex,tmpNeighbour);
		}
		for(int i=0;i<intersectionCounter1;i++){
			tmpNeighbour[0]=innerCounter1+innerCounter2+i;
			returnValue.addElement(intersection1[i],tmpNeighbour);
		}
		for(int i=0;i<intersectionCounter2;i++){
			tmpNeighbour[0]=innerCounter1+innerCounter2+intersectionCounter1+i;
			returnValue.addElement(intersection2[i],tmpNeighbour);
		}
		//todo
		//un errore nel vertice due di convexhull,non elinkato anche se esiste
		//casi particolari in caso uno dei 2 non abbia vertici all'interno dell'altro(tetraedo per i cubi)
		//rotato non va una mazzza
		returnValue=getConvexHull(returnValue);
		returnValue.isReal=false;
		returnValue.setColor(CoreConstant.COLLISIONENGINE_COLOR);
		return returnValue;
		
		/*remapping=new int[d2.size()];
		
		for(int i=0;i<remapping.length;i++)
			remapping[i]=-1;
		for(int i=0;i<innerCounter;i++)
			remapping[inner[i]]=i;
		for(int i=0;i<innerCounter;i++){
			tmpNeighbour=d2.getNeighbours(inner[i]);
			for(int j=0;j<tmpNeighbour.length;j++)
				if(remapping[tmpNeighbour[j]]!=-1)
					tmpNeighbour[j]=remapping[tmpNeighbour[j]];
				else
					tmpNeighbour[j]=0;
			returnValue.addElement(d2.getVertex(inner[i]),tmpNeighbour);
		}*/
	/*	Geometry.setTransform(d1);
		tmpNeighbour=new int[1];
		tmpVertex=Geometry.getTransformedVertex(d1.getVertex(inner1[0]));
		returnValue.addElement(tmpVertex,tmpNeighbour);
		for(int i=0;i<intersectionCounter1;i++){
			tmpNeighbour=new int[2];
			tmpNeighbour[0]=1+i;
			tmpNeighbour[1]=0;
			returnValue.addElement(intersection1[i],(int[])(tmpNeighbour.clone()),Integer.toString(i));
		}*/
		
/*		Geometry.setTransform(d2);
		tmpNeighbour=new int[1];
		tmpVertex=Geometry.getTransformedVertex(d2.getVertex(inner2[0]));
		returnValue.addElement(tmpVertex,tmpNeighbour);
		for(int i=0;i<intersectionCounter2;i++){
			tmpNeighbour=new int[2];
			tmpNeighbour[0]=1+i;
			tmpNeighbour[1]=0;
			returnValue.addElement(intersection2[i],(int[])(tmpNeighbour.clone()),Integer.toString(i));
		}*/
/*		returnValue.isReal=false;
		returnValue.setColor(CoreConstant.COLLISIONENGINE_COLOR);
	//	returnValue.setScale(d2.getScale());
	//	returnValue.setTranslate(d2.getTranslate());
	//	returnValue.setRotate(d2.getRotate());
		System.out.println(returnValue.toString());
		return returnValue;*/
		
		//costurizoni origini per 1 e 2:
		//costruisco lengthorigini partendo dai vertici in oridini,trovao faccie 
		
		
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
		/*vertex1=new int[d1.size()][];
		vertex1[0]=new int[1];
		vertex1[0][0]=nearest1;
		 
		tmpNeighbour=d1.getNeighbours(nearest1);
		vertex1[1]=new int[tmpNeighbour.length];
		for(int i=0;i<tmpNeighbour.length;i++){
			vertex1[1][i]=tmpNeighbour[i];
		}
		neighbour1=new int[d1.size()-1][];
		neighbour1[0]=new int[1];
		neighbour1[0][0]=tmpNeighbour.length;
		 
		vertex2=new int[d2.size()][];
		vertex2[0]=new int[1];
		vertex2[0][0]=nearest2;
		 
		tmpNeighbour=d2.getNeighbours(nearest2);
		vertex2[1]=new int[tmpNeighbour.length];
		for(int i=0;i<tmpNeighbour.length;i++){
			vertex2[1][i]=tmpNeighbour[i];
		}
		neighbour2=new int[d2.size()-1][];
		neighbour2[0]=new int[1];
		neighbour2[0][0]=tmpNeighbour.length;
		 
		for(int i=0;i<vertex1.length;i++)
			for(int j=0;vertex1[i]!=null && j<vertex1[i].length;j++)
				System.out.println("ij "+ i+" " +j+" vertex1 "+vertex1[i][j]);
		 
		for(int i=0;i<vertex2.length;i++)
			for(int j=0;vertex2[i]!=null && j<vertex2[i].length;j++)
				System.out.println("ij "+ i+" " +j+" vertex2 "+vertex2[i][j]);
		 
		for(int i=0;i<neighbour1.length;i++)
			for(int j=0;neighbour1[i]!=null && j<neighbour1[i].length;j++)
				System.out.println("ij "+ i+" " +j+" neighbour1 "+neighbour1[i][j]);
		 
		for(int i=0;i<neighbour2.length;i++)
			for(int j=0;neighbour2[i]!=null && j<neighbour2[i].length;j++)
				System.out.println("ij "+ i+" " +j+" neighbour2 "+neighbour2[i][j]);
		//build d1 part:
		//calculating d2 construction set (normals,origins and so on)
		//while i can add neighbours that are under d2 add them
		//no add? d1 hul is finished(inside only,another level nedded
		// to complete for intersection with d2 hull
		 
		//calculating d2 init
		 
		normal2=new double[vertex2[1].length-1][4];
		origin2=new double[vertex2[1].length-1][4];
		tmpOrigin=new double[3][];
		base1=new double[4];
		base2=new double[4];
		Geometry.setTransform(d2);
		for(int i=0;i<normal2.length;i++){
			for(int k=0;k<4;k++){
				base1[k]=d2.getVertex(vertex2[1][i])[k]-d2.getVertex(vertex2[0][0])[k];
				base2[k]=d2.getVertex(vertex2[1][i+1])[k]-d2.getVertex(vertex2[0][0])[k];
			}
			normal2[i]=Geometry.cross(base1,base2);
			normal2[i]=Geometry.normalize(normal2[i]);
			tmpOrigin[0]=d2.getVertex(vertex2[1][i]);
			tmpOrigin[1]=d2.getVertex(vertex2[1][i+1]);
			tmpOrigin[2]=d2.getVertex(vertex2[0][0]);
			origin2[i]=Geometry.getBaricenter(tmpOrigin);
			origin2[i]=Geometry.getTransformedVertex(origin2[i]);
			versus=Geometry.pointToVector(origin2[i],baricenter2);
			if(Geometry.cos(normal2[i],versus)<0)
				normal2[i]=Geometry.valueProduct(normal2[i],-1);
			//controllare normali abbiano verso giusto prima di trasformare le origini(sono utili)?
		}
		for(int i=0;i<normal2.length;i++)
			for(int j=0;j<4;j++)
				System.out.println("i: "+i+"normal2["+j+"] " +normal2[i][j]+" origin2["+i+"] "+origin2[i][j]);
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 
		returnValue=new Draw();
		count=1;
		Geometry.setTransform(d1);
		for(int i=0;i<vertex1.length;i++)
			for(int j=0;vertex1[i]!=null && j<vertex1[i].length;j++){
				System.out.println("i: "+i+" j "+j);
				tmpVertex=d1.getVertex(vertex1[i][j]);
				if(neighbour1[i]!=null){
					tmpNeighbour=new int[neighbour1[i][j]];
					for(int k=0;k<tmpNeighbour.length;k++)
						tmpNeighbour[k]=count+k;
					count+=tmpNeighbour.length;
				}else
					tmpNeighbour=new int[0];
				tmpVertex=Geometry.getTransformedVertex(tmpVertex);
				returnValue.addElement((double[])((tmpVertex).clone()),(int[])(tmpNeighbour.clone()),Integer.toString(vertex1[i][j]));
			}
		count++;
		Geometry.setTransform(d2);
		for(int i=0;i<vertex2.length;i++)
			for(int j=0;vertex2[i]!=null && j<vertex2[i].length;j++){
				tmpVertex=d2.getVertex(vertex2[i][j]);
				if(neighbour2[i]!=null && j<neighbour2[i].length){
					tmpNeighbour=new int[neighbour2[i][j]];
					System.out.println("i: "+i+" j "+j+ " vertex2.length " +vertex2.length +" vertex2[i].length " +vertex2[i].length + " neighbour2.length "+neighbour2.length +" neighbour2[i].lenght "+neighbour2[i].length);
					for(int k=0;k<tmpNeighbour.length;k++){
						System.out.println("neighbour2["+i+"]["+j+"] "+neighbour2[i][j]);
						tmpNeighbour[k]=count+k;
					}
					count+=tmpNeighbour.length;
				}else
					tmpNeighbour=new int[0];
				tmpVertex=Geometry.getTransformedVertex(tmpVertex);
				returnValue.addElement((double[])((tmpVertex).clone()),(int[])(tmpNeighbour.clone()),Integer.toString(vertex2[i][j]));
			}
		returnValue.setColor(CoreConstant.COLLISIONENGINE_COLOR);
		returnValue.isReal=false;
		System.out.println(returnValue);
		return returnValue;
	}*/
	
	
	
	
		/* nearest1=Geometry.findRealNearest(d1,baricenter2);
		nearest2=Geometry.findRealNearest(d2,baricenter1);
		System.out.println("nearest1 " +nearest1 +" nearest2 "+ nearest2);
		//prima faccia
		neighbour=d1.getNeighbours(nearest1);
		for(int i=0;i<neighbour.length;i++){
			System.out.println("neighbour["+i+"] "+neighbour[i]);
			tmpVertex=d1.getVertex(neighbour[i]);
			System.out.println("distance " +Geometry.distance(tmpVertex,baricenter2));
			if(Geometry.distance(tmpVertex,baricenter2)>max){
				System.out.println("vertex1 setted " + i);
				max=Geometry.distance(tmpVertex,baricenter2);
				vertex1=i;
			}
			if(Geometry.distance(tmpVertex,baricenter2)>max2 && i!=vertex1){
				System.out.println("vertex2 setted " + i);
				max2=Geometry.distance(tmpVertex,baricenter2);
				vertex2=i;
			}
		}
		//prova
		returnValue=new Draw();
		neighbour=new int[1];
		neighbour[0]=1;
		returnValue.addElement((double[])((d1.getVertex(nearest1)).clone()),(int[])(neighbour.clone()),Integer.toString(nearest1));//7
		neighbour[0]=2;
		returnValue.addElement((double[])((d1.getVertex(vertex1)).clone()),(int[])(neighbour.clone()),Integer.toString(vertex1));//7
		neighbour[0]=0;
		returnValue.addElement((double[])((d1.getVertex(vertex2)).clone()),(int[])(neighbour.clone()),Integer.toString(vertex2));//7
		returnValue.setColor(CoreConstant.COLLISIONENGINE_COLOR);
		returnValue.isReal=false;
		returnValue.setScale(first.getScale());
		returnValue.setTranslate(first.getTranslate());
		returnValue.setRotate(first.getRotate());
		System.out.println(returnValue);
		return returnValue;
		 
	} */
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	//		Draw d1,d2,returnValue;
	//		double[] baricenter1,baricenter2,tmpVertex;
	//		int nearest1,nearest2;
	//		int frontier[];
	//		int[][] shell1=new int[first.size()][first.size()],shell2=new int[second.size()][second.size()];
	//		int level1,level2,vertex1,vertex2;
	//		double[] x1,x2,y1,y2,z1,z2,tmpVertex;
	//		int[] px1,py1,pz1,px2,py2,pz2,incidencex1,incidencey1,incidencez1,incidencex2,incidencey2,incidencez2;
	//		boolean x=false,y=false,z=false;
	//		int count1,count2;
	//		Draw tmpDraw;
	//
	//		d1=getConvexHull(first);
	//		d2=getConvexHull(second);
	//		double[][] vertex=new double[d1.size()][];
	//		int[][] neighbour=new int[d1.size()][];
	//		baricenter1=Geometry.getBaricenter(d1);
	//		baricenter2=Geometry.getBaricenter(d2);
	//		Geometry.setTransform(d1);
	//		baricenter1=Geometry.getTransformedVertex(baricenter1);
	//		Geometry.setTransform(d2);
	//		baricenter2=Geometry.getTransformedVertex(baricenter2);
	//		nearest1=Geometry.findRealNearest(d1,baricenter2);
	//		nearest2=Geometry.findRealNearest(d2,baricenter1);
	//		//trovati punti iniziali
	//		//costruzione primo guscio
	//		for(int i=0;i<shell1.length;i++)
	//			for(int j=0;j<shell1[i].length;j++)
	//				shell1[i][j]=-1;
	//		for(int i=0;i<shell2.length;i++)
	//			for(int j=0;j<shell2[i].length;j++)
	//				shell2[i][j]=-1;
	//		shell1[0][0]=nearest1;
	//		shell2[0][0]=nearest2;
	//		frontier=d1.getNeighbours(nearest1);
	//		for(int i=0;i<frontier.length;i++)
	//			shell1[1][i]=frontier[i];
	//		frontier=d2.getNeighbours(nearest2);
	//		for(int i=0;i<frontier.length;i++)
	//			shell2[1][i]=frontier[i];
	//		level1=2;
	//		level2=2;
	//		frontier=shell1[1];
	
	//finche i punti della frontiera non sbordano
	//aggiungi la frontiera al guc�scio
	//se la frontiera straborda la forntiera fa parte dell intersezione
	//crea la seconda frontiera
	//finche la forntiera2 e maggiore del guscio aggiungi
	
	
	//se la frontiera2 e maggiore di un livello inferiore della frontiera1
	//		returnValue=new Draw();
	//		vertex[0]=d1.getVertex(nearest1);
	//		neighbour[0]=d1.getNeighbours(nearest1);
	//		for(int i=0;i<neighbour[0].length;i++){
	//			System.out.println("neigh " +neighbour[0][i]);
	//			vertex[i+1]=d1.getVertex(neighbour[0][i]);
	//			neighbour[0][i]=i+1;
	//		}
	//		returnValue.addElement((double[])(vertex[0].clone()),(int[])(neighbour[0].clone()),"init");
	//		int[] tmp=new int[1];
	//		for(int i=0;i<neighbour[0].length;i++){
	//			tmp[0]=i+1;
	//			returnValue.addElement((double[])(vertex[i+1].clone()),(int[])tmp.clone());
	//		}
	//		System.out.println("Draw/n" +returnValue);
	//		returnValue.isReal=false;
	//		returnValue.setColor(CoreConstant.COLLISIONENGINE_COLOR);
	//		returnValue.setTranslate(d1.getTranslate());
	//		returnValue.setRotate(d1.getRotate());
	//		returnValue.setScale(d1.getScale());
	//		return returnValue;
	//		for(int i=0;i<d1.size();i=i+3){
	//			baricenter1[0]=d1.getVertex(i);
	//			baricenter1[1]=d1.getVertex(i+1);
	//			baricenter1[2]=d1.getVertex(i+2);
	//			origin1[i/3]=Geometry.getBaricenter(baricenter1);
	//		}
	//		for(int i=0;i<d2.size();i=i+3){
	//			baricenter2[0]=d2.getVertex(i);
	//			baricenter2[1]=d2.getVertex(i+1);
	//			baricenter2[2]=d2.getVertex(i+2);
	//			origin2[i/3]=Geometry.getBaricenter(baricenter2);
	//		}
	//		x1=new double[d1.size()];
	//		y1=new double[d1.size()];
	//		z1=new double[d1.size()];
	//		x2=new double[d2.size()];
	//		y2=new double[d2.size()];
	//		z2=new double[d2.size()];
	//		px1=new int[d1.size()];
	//		py1=new int[d1.size()];
	//		pz1=new int[d1.size()];
	//		px2=new int[d2.size()];
	//		py2=new int[d2.size()];
	//		pz2=new int[d2.size()];
	//		incidencex1=new int[d1.size()];
	//		incidencey1=new int[d1.size()];
	//		incidencez1=new int[d1.size()];
	//		incidencex2=new int[d2.size()];
	//		incidencey2=new int[d2.size()];
	//		incidencez2=new int[d2.size()];
	//		for(int i=0;i<incidencex1.length;i++){
	//			incidencex1[i]=-1;
	//			incidencey1[i]=-1;
	//			incidencez1[i]=-1;
	//		}
	//		for(int i=0;i<incidencex2.length;i++){
	//			incidencex2[i]=-1;
	//			incidencey2[i]=-1;
	//			incidencez2[i]=-1;
	//		}
	//		Geometry.setTransform(d1);
	//		for(int i=0;i<d1.size();i++){
	//			tmpVertex=Geometry.getTransformedVertex(d1.getVertex(i));
	//			x1[i]=tmpVertex[0];
	//			px1[i]=i;
	//			y1[i]=tmpVertex[1];
	//			py1[i]=i;
	//			z1[i]=tmpVertex[2];
	//			pz1[i]=i;
	//		}
	//		Geometry.setTransform(d2);
	//		for(int i=0;i<d2.size();i++){
	//			tmpVertex=Geometry.getTransformedVertex(d2.getVertex(i));
	//			x2[i]=tmpVertex[0];
	//			px2[i]=i;
	//			y2[i]=tmpVertex[2];
	//			py2[i]=i;
	//			z2[i]=tmpVertex[2];
	//			pz2[i]=i;
	//		}
	//		Util.sortWithPosition(x1,px1);
	//		Util.sortWithPosition(y1,py1);
	//		Util.sortWithPosition(z1,pz1);
	//		Util.sortWithPosition(x2,px2);
	//		Util.sortWithPosition(y2,py2);
	//		Util.sortWithPosition(z2,pz2);
	//		return d1;
	//		double[] baricenter1,baricenter2;
	//		int[] init1=new int[d1.size()],init2;
	//		int initCounter1=0,initCounter2=0;
	//		int[][] vertex;
	//
	//		baricenter1=Geometry.getBaricenter(d1);
	//		baricenter2=Geometry.getBaricenter(d2);
	//		init1[initCounter1++]=Geometry.findNearestVertexByPosition(d1,baricenter2);
	//		init2[initCounter2++]=Geometry.findNearestVertexByPosition(d2,baricenter1);
	//		for(int i=0;i<d1.size();i++)
	//			if(equal(d1.getVertex(init1[0]),d1.getVertex(i)))
	//				init1[initCounter1++]=i;
	//		for(int i=0;i<d2.size();i++)
	//			if(equal(d2.getVertex(init1[0]),d2.getVertex(i)))
	//				init1[initCounter2++]=i;
	//		vertex[0][0]=init1[0];
	//		return d1;
	//	}
	
	protected static boolean notIn(int index,int[] ware){
		
		for(int i=0;i<ware.length;i++)
			if(index==ware[i])
				return false;
		return true;
	}
	
	protected static boolean isIn(int index,int[] ware){
		
		for(int i=0;i<ware.length;i++)
			if(index==ware[i])
				return true;
		return false;
	}
	
	protected boolean notAll(int index,int[] ware){
		
		for(int i=0;i<ware.length;i++)
			if(index!=ware[1])
				return false;
		return true;
	}
	
	public static DrawPlus getConvexHull(Draw first){
		
		int facets=0,point=-1,facet=-1,tmpPoint=-1,visibileCount=-1,dimension=5*first.size()-4,debug=0,bufferCount=0,eliminate=0;
		int[] neighbour,tmpFacet1=new int[3],tmpFacet2=new int[3],tmpFacet3=new int[3],visibile=new int[dimension],buffer=new int[dimension];;
		int[][] vertex=new int[dimension][3]; //modificato...e giusto il numero di faccie?
		boolean allprocessed=false,remove=false,split,insert;
		boolean[] closed=new boolean[first.size()],processed=new boolean[first.size()];
		double[][] normal=new double[dimension][4],origin=new double[dimension][4],baricenter=new double[3][4],distance=new double[dimension][first.size()];
		double[] base1=new double[4],base2=new double[4],tmpVertex=new double[4];
		double tmpValue=0,max=0;
		DrawPlus returnValue=new DrawPlus();
		
		for(int i=0;i<vertex.length;i++)
			for(int j=0;j<vertex[i].length;j++)
				vertex[i][j]=-1;
		for(int i=0;i<processed.length;i++)
			processed[i]=false;
		for(int i=0;i<closed.length;i++)
			closed[i]=false;
		for(int i=0;i<buffer.length;i++)
			buffer[i]=-1;
		vertex[0][0]=0;
		vertex[0][1]=1;
		for(int i=0;i<4;i++)
			base1[i]=first.getVertex(vertex[0][1])[i]-first.getVertex(vertex[0][0])[i];
		for(int i=2;i<first.size() && vertex[0][2]==-1;i++){
			tmpVertex=first.getVertex(i);
			for(int j=0;j<4;j++)
				base2[j]=tmpVertex[j]-first.getVertex(vertex[0][0])[j];
			tmpVertex=Geometry.cross(base1,base2);
			if(Geometry.valid(tmpVertex) && (tmpVertex[0]!=0 || tmpVertex[1]!=0 || tmpVertex[2]!=0)){
				vertex[0][2]=i;
				processed[i]=true;
			}
		}
		processed[0]=true;
		processed[1]=true;
		/*for(int i=0;i<4;i++){
			base1[i]=first.getVertex(vertex[0][1])[i]-first.getVertex(vertex[0][0])[i];
			base2[i]=first.getVertex(vertex[0][2])[i]-first.getVertex(vertex[0][0])[i];
		}*/
		normal[0]=Geometry.cross(base1,base2);
		normal[0]=Geometry.normalize(normal[0]);
		baricenter[0]=first.getVertex(vertex[0][0]);
		baricenter[1]=first.getVertex(vertex[0][1]);
		baricenter[2]=first.getVertex(vertex[0][2]);
		origin[0]=Geometry.getBaricenter(baricenter);
		for(int i=3;i<first.size() && vertex[1][0]==-1;i++)
			if(!processed[i]){
				tmpVertex=first.getVertex(i);
				/*for(int j=0;j<4;j++)
					tmpValue+=normal[0][j]*(tmpVertex[j]-first.getVertex(vertex[0][0])[j]);*/
				tmpValue=Geometry.distancePP(normal[0],origin[0],tmpVertex);
				if(tmpValue!=0){
					vertex[1][0]=i;
					vertex[1][1]=vertex[0][0];
					vertex[1][2]=vertex[0][1];
					vertex[2][0]=i;
					vertex[2][1]=vertex[0][1];
					vertex[2][2]=vertex[0][2];
					vertex[3][0]=i;
					vertex[3][1]=vertex[0][0];
					vertex[3][2]=vertex[0][2];
					processed[i]=true;
				}
			}//non considerato caso \planare
		facets=4;
		for(int i=0;i<facets;i++){
			baricenter[0]=first.getVertex(vertex[i][0]);
			baricenter[1]=first.getVertex(vertex[i][1]);
			baricenter[2]=first.getVertex(vertex[i][2]);
			origin[i]=Geometry.getBaricenter(baricenter);
		}
		for(int i=0;i<facets;i++){
			for(int j=0;j<4;j++){
				base1[j]=first.getVertex(vertex[i][1])[j]-first.getVertex(vertex[i][0])[j];
				base2[j]=first.getVertex(vertex[i][2])[j]-first.getVertex(vertex[i][0])[j];
				tmpVertex[j]=origin[(i-1+facets)%facets][j]-origin[i][j];
			}
			normal[i]=Geometry.cross(base1,base2);
			normal[i]=Geometry.normalize(normal[i]);
			if(Geometry.cos(normal[i],tmpVertex)>0)
				for(int j=0;j<4;j++)
					normal[i][j]=normal[i][j]*(-1);
		}
		//finito l'init normali baricentri e vertici e processati
		
//				for(int i=0;i<facets;i++)
//					System.out.println("facets "+i + " "+ vertex[i][0]+ " " + vertex[i][1]+ " "+ vertex[i][2]);
		//		for(int i=0;i<facets;i++)
		//				for(int k=0;k<4;k++)
		//					System.out.println(i +": normal["+k+"] "+ normal[i][k] + " origin["+k+"] " +origin[i][k]);
		
		//inizi6547o ciclo sui vertici
		//		allprocessed=true; //da togliere:
		allprocessed=false;
		while(!allprocessed && debug<10000){
			debug++;
			//calcolare distance
			//			System.out.println("--------------------------------------------------------");
			//trovare punto da inserire e faccia(per comodit�)
			max=0;
			visibileCount=0;
			split=true;
			allprocessed=true;
			remove=true;
			for(int i=0;i<visibile.length;i++)
				visibile[i]=-1;
			for(int i=0;i<facets;i++)
				for(int j=0;j<first.size();j++)
					distance[i][j]=0;
			for(int i=0;i<closed.length;i++)
				closed[i]=false;
			for(int i=0;i<distance.length;i++)
				for(int j=0;j<distance[i].length;j++)
					distance[i][j]=Double.NEGATIVE_INFINITY;
			
			for(int i=0;i<facets;i++)
				for(int j=0;j<first.size();j++)
					if(!processed[j] && notIn(i,buffer)){
						for(int k=0;k<4;k++)
							tmpVertex[k]=first.getVertex(j)[k]-origin[i][k];
						distance[i][j]=Geometry.dotProduct(normal[i],tmpVertex);
						if(distance[i][j]>max){
							max=distance[i][j];
							point=j;
							facet=i;
						}
					}
			//			for(int i=0;i<facets;i++)
			//				for(int j=0;j<first.size();j++)
			//					System.out.println("distance for facet " +i +" to vertex "+j+ " : " +distance[i][j]);
			//metto in processed tutti i punti che hanno distanze negative a tutte la faccie
			for(int i=0;i<first.size();i++){
				for(int j=0;j<facets;j++)
					if(distance[j][i]>=0)
						remove=false;
				if(remove && processed[i]==false){
//					System.out.println("\n\nrimosso "+i+"\n\n");
					processed[i]=true;
				}
				remove=true;
			}
			//trovare faccie visibili
			for(int i=0;i<facets;i++)
				if(notIn(i,buffer) && distance[i][point]>=0)
					visibile[visibileCount++]=i;
			//calcolo di vertici chiusi
			//			for(int i=0;i<visibile.length && visibile[i]!=-1;i++)
			//				System.out.println(i+" Faccia visibile: "+visibile[i]);
			for(int j=0;j<first.size();j++)
				for(int i=0;i<visibile.length && visibile[i]!=-1;i++)
					if(isIn(j,vertex[visibile[i]]))
						for(int k=0;k<facets;k++)
							if(notIn(k,visibile) && isIn(j,vertex[k]))
								closed[j]=false;			//macello
			//se non esistono vertici chiusi split di faccie(una o piu secondo visibile)non inserisco faccie doppie
			for(int i=0;i<closed.length;i++)
				if(closed[i])
					split=false;
			//SPLIT!!!!!!!!!!!
			//			System.out.println("facets " +facets+" vertex l "+vertex.length);
			//			for(int i=0;i<visibile.length;i++)
			//				System.out.println("visibile["+i+"] " +visibile[i]);
			
			if(split)
				for(int i=0;i<visibile.length && visibile[i]!=-1;i++){
					
					//						System.out.println("processo la faccia visibile "+visibile[i]);
					tmpFacet1[0]=point;
					tmpFacet1[1]=vertex[visibile[i]][0];
					tmpFacet1[2]=vertex[visibile[i]][1];
					tmpFacet2[0]=point;
					tmpFacet2[1]=vertex[visibile[i]][0];
					tmpFacet2[2]=vertex[visibile[i]][2];
					tmpFacet3[0]=point;
					tmpFacet3[1]=vertex[visibile[i]][1];
					tmpFacet3[2]=vertex[visibile[i]][2];
					facet=visibile[i];
					//						System.out.println("faccie create :");
					//						for(int j=0;j<3;j++)
					//							System.out.println(" faccia 1: " +tmpFacet1[j]);
					//						for(int j=0;j<3;j++)
					//							System.out.println(" faccia 2: " +tmpFacet2[j]);
					//						for(int j=0;j<3;j++)
					//							System.out.println(" faccia 3: " +tmpFacet3[j]);
					insert=true;
					for(int k=0;k<facets;k++)
						if(equal(tmpFacet1,vertex[k])){
							insert=false;
							buffer[bufferCount++]=k;
						}
					if(insert)
						if(bufferCount!=0){
							bufferCount--;
							vertex[buffer[bufferCount]][0]=tmpFacet1[0];
							vertex[buffer[bufferCount]][1]=tmpFacet1[1];
							vertex[buffer[bufferCount]][2]=tmpFacet1[2];
							buffer[bufferCount]=-1;
							//								System.out.println("faccia 1 inserita in buffer "+ buffer);
						} else if(visibile[i]!=-1){//usato come indice se utliziabile,tanto non l ouso piu
							vertex[facet][0]=tmpFacet1[0];
							vertex[facet][1]=tmpFacet1[1];
							vertex[facet][2]=tmpFacet1[2];
							//									System.out.println("faccia 1 inserita in visibile "+ visibile[i]);
							visibile[i]=-1;
						}else{
							vertex[facets][0]=tmpFacet1[0];
							vertex[facets][1]=tmpFacet1[1];
							vertex[facets++][2]=tmpFacet1[2];
							//									System.out.println("faccia 1 inserita in coda "+ facets);
						}
					
					insert=true;
					for(int k=0;k<facets;k++)
						if(equal(tmpFacet2,vertex[k])){
							insert=false;
							buffer[bufferCount++]=k;
						}
					if(insert)
						if(bufferCount!=0){
							bufferCount--;
							vertex[buffer[bufferCount]][0]=tmpFacet2[0];
							vertex[buffer[bufferCount]][1]=tmpFacet2[1];
							vertex[buffer[bufferCount]][2]=tmpFacet2[2];
							buffer[bufferCount]=-1;
							//								System.out.println("faccia 2 inserita in buffer "+ buffer);
						} else if(visibile[i]!=-1){//usato come indice se utliziabile,tanto non l ouso piu
							vertex[facet][0]=tmpFacet2[0];
							vertex[facet][1]=tmpFacet2[1];
							vertex[facet][2]=tmpFacet2[2];
							//								System.out.println("faccia 2 inserita in visibile "+ visibile[i]);
							visibile[i]=-1;
						}else{
							vertex[facets][0]=tmpFacet2[0];
							vertex[facets][1]=tmpFacet2[1];
							vertex[facets++][2]=tmpFacet2[2];
							//									System.out.println("faccia 2 inserita in coda "+ facets);
						}
					
					insert=true;
					for(int k=0;k<facets;k++)
						if(equal(tmpFacet3,vertex[k])){
							insert=false;
							buffer[bufferCount++]=k;
						}
					if(insert)
						if(bufferCount!=0){
							bufferCount--;
							vertex[buffer[bufferCount]][0]=tmpFacet3[0];
							vertex[buffer[bufferCount]][1]=tmpFacet3[1];
							vertex[buffer[bufferCount]][2]=tmpFacet3[2];
							buffer[bufferCount]=-1;
							//								System.out.println("faccia 3 inserita in buffer "+ buffer);
						} else
							if(visibile[i]!=-1){//usato come indice se utliziabile,tanto non l ouso piu
								vertex[facet][0]=tmpFacet3[0];
								vertex[facet][1]=tmpFacet3[1];
								vertex[facet][2]=tmpFacet3[2];
								//									System.out.println("faccia 3 inserita in visibile "+ visibile[i]);
								visibile[i]=-1;
							}else{
								vertex[facets][0]=tmpFacet3[0];
								vertex[facets][1]=tmpFacet3[1];
								vertex[facets++][2]=tmpFacet3[2];
								//									System.out.println("faccia 3 inserita in coda "+ facets);
							}
					if(visibile[i]!=-1){
						buffer[bufferCount++]=visibile[i];
						visibile[i]=-1;
					}
				}
			else
				//se esistono vertici chiusi rimpiazzamento dei vertici chiusi col punto
				for(int j=0;j<first.size();j++)
					if(closed[j])
						for(int i=0;i<facets;i++) {
							//								System.out.println("\n\nrimpiazzo\n\n");
							replace(vertex[i],j,point);
						}
			processed[point]=true;
			for(int i=0;i<processed.length;i++)
				if(!processed[i])
					allprocessed=false;
			
			
			//ho processato il punto
			//se tutti punti processati allprocessed=true
			//ricalcolare normli no eh?
			baricenter=new double[3][];
			for(int i=0;i<facets;i++){
				baricenter[0]=first.getVertex(vertex[i][0]);
				baricenter[1]=first.getVertex(vertex[i][1]);
				baricenter[2]=first.getVertex(vertex[i][2]);
				origin[i]=Geometry.getBaricenter(baricenter);
			}
			baricenter=new double[1][4];
			for(int i=0;i<facets;i++)
				for(int j=0;j<3;j++)
					baricenter[0][j]+=origin[i][j]/facets;
			for(int i=0;i<facets;i++){
				for(int j=0;j<4;j++){
					base1[j]=first.getVertex(vertex[i][1])[j]-first.getVertex(vertex[i][0])[j];
					base2[j]=first.getVertex(vertex[i][2])[j]-first.getVertex(vertex[i][0])[j];
					tmpVertex[j]=baricenter[0][j]-origin[i][j];
				}
				normal[i]=Geometry.cross(base1,base2);
				normal[i]=Geometry.normalize(normal[i]);
				if(Geometry.cos(normal[i],tmpVertex)>0)
					for(int j=0;j<4;j++)
						normal[i][j]=normal[i][j]*(-1);
			}
			//			System.out.println("point "+point);
			//			for(int i=0;i<first.size();i++)
			//				System.out.println("processed["+i+"] "+processed[i]);
			//			System.out.println("split "+split);
			//			for(int i=0;i<facets;i++)
			//					System.out.println("facet: "+ i+" "+ vertex[i][0]+" "+ vertex[i][1]+" "+ vertex[i][2]);
			//			for(int i=0;i<bufferCount;i++)
			//				System.out.println("buffer["+i+"]: "+buffer[i]);
		}
		for(int i=0;i<bufferCount;i++){
			normal[buffer[i]][0]=normal[facets-1][0];
			normal[buffer[i]][1]=normal[facets-1][1];
			normal[buffer[i]][2]=normal[facets-1][2];
			normal[buffer[i]][3]=normal[facets-1][3];
			origin[buffer[i]][0]=origin[facets-1][0];
			origin[buffer[i]][1]=origin[facets-1][1];
			origin[buffer[i]][2]=origin[facets-1][2];
			origin[buffer[i]][3]=origin[facets-1][3];
			vertex[buffer[i]][0]=vertex[facets-1][0];
			vertex[buffer[i]][1]=vertex[facets-1][1];
			vertex[buffer[i]][2]=vertex[facets-1][2];
			facets-=1;
		}
		//		System.out.println("debug "+debug);
		int[] tmpNeighbour=new int[first.size()];
		int[][] neighbourBuffer=new int[first.size()][first.size()];;
		int processing,neighbourCounter,counter;
		//init
		for(int i=0;i<first.size();i++)
			for(int j=0;j<first.size();j++)
				neighbourBuffer[i][j]=-1;
		for(int i=0;i<processed.length;i++)
			processed[i]=false;
		//torvo vertici vicini
		for(int i=0;i<facets;i++){
			//			System.out.println("faccia " +i);
			//			for(int j=0;j<buffer.length;j++)
			//				System.out.println("buffer["+j+"] "+ buffer[j]);
			if(notIn(i,buffer,bufferCount))
				for(int j=0;j<3;j++)
					if(!processed[vertex[i][j]]){
						//						System.out.println("processo faccia" + i + " vertice "+j +" val: "+vertex[i][j]);
						processing=vertex[i][j];
						processed[vertex[i][j]]=true;
						neighbourCounter=0;
						for(int k=0;k<facets;k++)
							if(notIn(k,buffer,bufferCount) && isIn(processing,vertex[k]))
								for(int j1=0;j1<3;j1++)
									if(vertex[k][j1]!=processing && notIn(vertex[k][j1],neighbourBuffer[processing],neighbourCounter))
										neighbourBuffer[processing][neighbourCounter++]=vertex[k][j1];
					}
		}
/*		for(int i=0;i<neighbourBuffer.length;i++)
			for(int j=0;j<neighbourBuffer[i].length && neighbourBuffer[i][j]!=-1;j++)
				System.out.println("neighbour["+i+"] "+neighbourBuffer[i][j]);*/
		for(int i=0;i<first.size();i++){
			counter=0;
			for(int j=0;j<neighbourBuffer[i].length && neighbourBuffer[i][j]!=-1;j++)
				counter++;
			tmpNeighbour=new int[counter];
			for(int j=0;j<tmpNeighbour.length;j++)
				tmpNeighbour[j]=neighbourBuffer[i][j];
			returnValue.addElement((double[])(first.getVertex(i).clone()),(int[])(tmpNeighbour.clone()));
		}
		
		//		for(int i=0;i<processed.length;i++)
		//			processed[i]=false;
		//		neighbour=new int[3];
		//		for(int i=0;i<facets;i++){
		//			if(notIn(i,buffer,bufferCount))
		//				for(int j=0;j<3;j++){
		//					tmpVertex=first.getVertex(vertex[i][j]);
		//					System.out.println("vertex["+i+"]"+"["+j+"] "+ vertex[i][j]);
		//					neighbour[0]=(i-eliminate)*3+(j+1)%3;
		//					neighbour[1]=(i-eliminate)*3+(j+2)%3;
		//					if(processed[vertex[i][j]])
		//						returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()));
		//					else{
		//						returnValue.addElement((double[])(tmpVertex.clone()),(int[])(neighbour.clone()),Integer.toString(vertex[i][j]));
		//						processed[vertex[i][j]]=true;
		//					}
		//				}
		//			else
		//				eliminate++;
		//				System.out.println();
		//			}
		returnValue.isReal=false;
		returnValue.setColor(CoreConstant.COLLISIONENGINE_COLOR);
		returnValue.setScale(first.getScale());
		returnValue.setTranslate(first.getTranslate());
		returnValue.setRotate(first.getRotate());
		returnValue.setPlus(origin,normal,vertex,facets);
		//		System.out.println(returnValue);
		return returnValue;
	}
	
	protected static boolean equal(int[] v1,int[] v2){
		
		if(v1.length!=v2.length)
			return false;
		for(int i=0;i<v1.length;i++)
			if(notIn(v1[i],v2))
				return false;
		return true;
		
	}
	
	protected static void replace(int[] v,int toReplace,int replace){
		
		for(int i=0;i<v.length;i++)
			if(v[i]==toReplace)
				v[i]=replace;
	}
	
	protected static boolean notIn(int position,int[] buffer,int counter){
		
		for(int i=0;i<buffer.length && i<counter;i++)
			if(buffer[i]==position)
				return false;
		return true;
	}
}
