import java.awt.*;
import java.awt.event.*;
import java.awt.Panel;

public class ColorPanel extends Panel {

	static Color foreground,background;
	static Font font;
	
	static ColorCanvas redCanvas,blueCanvas,greenCanvas,colorCanvas;
	
	static Panel colorCanvasPanel,colorPanel,scrollbarPanel,centralPanel,downPanel;
	
	static Scrollbar redScrollbar,greenScrollbar,blueScrollbar;

	static Label colorPanelLabel,blueLabel,greenLabel,redLabel;
	
	ColorAdapter colorAdapter=new ColorAdapter();

	static Button okButton;
	static Button cancelButton;
	static Button applyButton;
	  
	public ColorPanel(Color foreground,Color background,Font font) {

		this.font=font;
		this.background=background;
		this.foreground=foreground;

		colorPanelLabel=new Label();
		colorPanelLabel.setForeground(foreground);
		colorPanelLabel.setBackground(background);
		colorPanelLabel.setFont(font);
		colorPanelLabel.setText(Constant.COLORPANEL_COLORSEL);
		colorPanelLabel.setAlignment(Label.CENTER);
		
		redScrollbar=new Scrollbar(Scrollbar.HORIZONTAL,Constant.COLORPANEL_INITCOLOR,Constant.COLORPANEL_GAPCOLOR,Constant.COLORPANEL_STARTCOLOR,Constant.COLORPANEL_ENDCOLOR);
		redScrollbar.setForeground(foreground);
		redScrollbar.setBackground(background);
		redScrollbar.setFont(font);
		redScrollbar.addAdjustmentListener(colorAdapter);
//		redScrollbar.addMouseListener(colorAdapter);

		greenScrollbar=new Scrollbar(Scrollbar.HORIZONTAL,Constant.COLORPANEL_INITCOLOR,Constant.COLORPANEL_GAPCOLOR,Constant.COLORPANEL_STARTCOLOR,Constant.COLORPANEL_ENDCOLOR);		
		greenScrollbar.setForeground(foreground);
		greenScrollbar.setBackground(background);
		greenScrollbar.setFont(font);
		greenScrollbar.addAdjustmentListener(colorAdapter);
//		greenScrollbar.addMouseListener(colorAdapter);
				
		blueScrollbar=new Scrollbar(Scrollbar.HORIZONTAL,Constant.COLORPANEL_INITCOLOR,Constant.COLORPANEL_GAPCOLOR,Constant.COLORPANEL_STARTCOLOR,Constant.COLORPANEL_ENDCOLOR);		
		blueScrollbar.setForeground(foreground);
		blueScrollbar.setBackground(background);
		blueScrollbar.setFont(font);
		blueScrollbar.addAdjustmentListener(colorAdapter);
//		blueScrollbar.addMouseListener(colorAdapter);
		
		redLabel=new Label();
		redLabel.setForeground(foreground);
		redLabel.setBackground(background);
		redLabel.setFont(font);
		redLabel.setText(Constant.RED);
		redLabel.setAlignment(Label.CENTER);
		
		greenLabel=new Label();
		greenLabel.setForeground(foreground);
		greenLabel.setBackground(background);
		greenLabel.setFont(font);
		greenLabel.setText(Constant.GREEN);
		greenLabel.setAlignment(Label.CENTER);

		blueLabel=new Label();
		blueLabel.setForeground(foreground);
		blueLabel.setBackground(background);
		blueLabel.setFont(font);
		blueLabel.setText(Constant.BLUE);
		blueLabel.setAlignment(Label.CENTER);
		
		redCanvas=new ColorCanvas();
		redCanvas.setColor(new Color(redScrollbar.getValue(),0,0));
		
		blueCanvas=new ColorCanvas();
		blueCanvas.setColor(new Color(0,0,blueScrollbar.getValue()));
		
		greenCanvas=new ColorCanvas();
		greenCanvas.setColor(new Color(0,greenScrollbar.getValue(),0));
		
		colorCanvas=new ColorCanvas();
		colorCanvas.setColor(new Color(redScrollbar.getValue(),greenScrollbar.getValue(),blueScrollbar.getValue()));
		
		colorPanel=new Panel();
		colorPanel.setForeground(foreground);
		colorPanel.setBackground(background);
		colorPanel.setFont(font);
		colorPanel.setLayout(new GridLayout(3,1));
		colorPanel.add(redCanvas);
		colorPanel.add(greenCanvas);
		colorPanel.add(blueCanvas);
		
		scrollbarPanel=new Panel();
		scrollbarPanel.setForeground(foreground);
		scrollbarPanel.setBackground(background);
		scrollbarPanel.setFont(font);
		scrollbarPanel.setLayout(new GridLayout(6,1));
		scrollbarPanel.add(redLabel);
		scrollbarPanel.add(redScrollbar);		
		scrollbarPanel.add(greenLabel);
		scrollbarPanel.add(greenScrollbar);
		scrollbarPanel.add(blueLabel);
		scrollbarPanel.add(blueScrollbar);
						
		colorCanvasPanel=new Panel();
		colorCanvasPanel.setLayout(new BorderLayout());
		colorCanvasPanel.add(colorCanvas,BorderLayout.CENTER);
		
		centralPanel=new Panel();
		centralPanel.setForeground(foreground);
		centralPanel.setBackground(background);
		centralPanel.setFont(font);
		centralPanel.setLayout(new GridLayout(1,4));
		centralPanel.add(colorPanel);
		centralPanel.add(scrollbarPanel);
		centralPanel.add(colorCanvasPanel);
		


		okButton=new Button(Constant.OK);
		okButton.setForeground(foreground);
		okButton.setBackground(background);
		okButton.setFont(font);
		okButton.addActionListener(colorAdapter);
		
		cancelButton=new Button(Constant.CANCEL);
		cancelButton.setForeground(foreground);
		cancelButton.setBackground(background);
		cancelButton.setFont(font);
		cancelButton.addActionListener(colorAdapter);
			
		applyButton=new Button(Constant.APPLY);
		applyButton.setForeground(foreground);
		applyButton.setBackground(background);
		applyButton.setFont(font);
		applyButton.addActionListener(colorAdapter);
				
		downPanel=new Panel();
		downPanel.setForeground(foreground);
		downPanel.setBackground(background);
		downPanel.setFont(font);
		downPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		downPanel.add(cancelButton);
		downPanel.add(applyButton);
		downPanel.add(okButton);
		

		setLayout(new BorderLayout());
		this.add(colorPanelLabel,BorderLayout.NORTH);
		this.add(centralPanel,BorderLayout.CENTER);
		this.add(downPanel,BorderLayout.SOUTH);
//		this.addMouseListener(colorAdapter);
	}
	
	public static Color getColor() {
	
		return(new Color(redScrollbar.getValue(),greenScrollbar.getValue(),blueScrollbar.getValue()));
	}
	
		public static void setPanelFont(Font calledfont){

		font=calledfont;
	}

	public Font getFont(){

		return(font);
	}

	public static void setPanelForeground(Color calledforeground){

		foreground=calledforeground;
	}

	public Color getForeground(){

		return(foreground);
	}

	public static void setPanelBackground(Color calledbackground){

		background=calledbackground;
	}

	public Color getBackground(){

		return(background);
	}

	public static void apply() {

		redScrollbar.setForeground(foreground);
		redScrollbar.setBackground(background);
		redScrollbar.setFont(font);
		blueScrollbar.setForeground(foreground);
		blueScrollbar.setBackground(background);
		blueScrollbar.setFont(font);
		greenScrollbar.setForeground(foreground);
		greenScrollbar.setBackground(background);
		greenScrollbar.setFont(font);
		colorPanelLabel.setForeground(foreground);
		colorPanelLabel.setBackground(background);
		colorPanelLabel.setFont(font);
		redLabel.setForeground(foreground);
		redLabel.setBackground(background);
		redLabel.setFont(font);
		blueLabel.setForeground(foreground);
		blueLabel.setBackground(background);
		blueLabel.setFont(font);
		greenLabel.setForeground(foreground);
		greenLabel.setBackground(background);
		greenLabel.setFont(font);
		redCanvas.setForeground(foreground);
		redCanvas.setBackground(background);
		redCanvas.setFont(font);
		blueCanvas.setForeground(foreground);
		blueCanvas.setBackground(background);
		blueCanvas.setFont(font);
		greenCanvas.setForeground(foreground);
		greenCanvas.setBackground(background);
		greenCanvas.setFont(font);
		colorCanvas.setForeground(foreground);
		colorCanvas.setBackground(background);
		colorCanvas.setFont(font);
		okButton.setFont(font);
		okButton.setForeground(foreground);
		okButton.setBackground(background);
		applyButton.setFont(font);
		applyButton.setForeground(foreground);
		applyButton.setBackground(background);
		cancelButton.setFont(font);
		cancelButton.setForeground(foreground);
		cancelButton.setBackground(background);
		downPanel.setFont(font);
		downPanel.setForeground(foreground);
		downPanel.setBackground(background);
	}
}