public class DrawBerzie extends Draw {

int degreeX,degreeY;
Matrix m,n,controlPoint;


	public DrawBerzie(int degreeX,int degreeY,int flag) {
	
		this.degreeX=degreeX;
		this.degreeY=degreeY;
		setColor(CoreConstant.DRAWBERZIE_COLOR);
		setType(CoreConstant.DRAWCANVAS_BERZIE);
	}
	
	public DrawBerzie(int degreeX,int degreeY) {
	
		double[] point=new double[4];
		
		this.degreeX=degreeX;
		this.degreeY=degreeY;
		for(int i=0;i<degreeX;i++)
			for(int j=0;j<degreeY;j++) {
				point[0]=(-(double)(degreeX-1)/2+i)*CoreConstant.DRAWBERZIE_UNIT;
				point[1]=(-(double)(degreeY-1)/2+j)*CoreConstant.DRAWBERZIE_UNIT;
				point[2]=CoreConstant.DRAWBERZIE_Z;
				point[3]=1.0;
				vertex.add(new DrawElement(((double[])point.clone())));
			}
		int[] neighbour=new int[4];
		for(int i=1;i<degreeX-1;i++)
			for(int j=1;j<degreeY-1;j++) {
				neighbour[0]=degreeY*i+j-1;
				neighbour[1]=degreeY*i+j+1;
				neighbour[2]=degreeY*(i-1)+j;
				neighbour[3]=degreeY*(i+1)+j;
				addNeighbours(getVertex(degreeY*i+j),((int[])neighbour.clone()));
			}
		neighbour=new int[3];
		for(int i=1;i<degreeY-1;i++) {
				neighbour[0]=i-1;
				neighbour[1]=i+1;
				neighbour[2]=degreeY+i;
				addNeighbours(getVertex(i),((int[])neighbour.clone()));
		}
		for(int i=1;i<degreeY-1;i++) {
				neighbour[0]=degreeY*(degreeX-1)+i-1;
				neighbour[1]=degreeY*(degreeX-1)+i+1;
				neighbour[2]=degreeY*(degreeX-2)+i;
				addNeighbours(getVertex(degreeY*(degreeX-1)+i),((int[])neighbour.clone()));
		}
		for(int i=1;i<degreeX-1;i++) {
				neighbour[0]=(i-1)*degreeY;
				neighbour[1]=(i+1)*degreeY;;
				neighbour[2]=degreeY*i+1;
				addNeighbours(getVertex(i*degreeY),((int[])neighbour.clone()));
		}
		for(int i=1;i<degreeX-1;i++) {
				neighbour[0]=i*degreeY-1;
				neighbour[1]=(i+2)*degreeY-1;
				neighbour[2]=degreeY*(i+1)-2;
				addNeighbours(getVertex(degreeY*(i+1)-1),((int[])neighbour.clone()));
		}
		neighbour=new int[2];
		neighbour[0]=1;
		neighbour[1]=degreeY;
		addNeighbours(getVertex(0),((int[])neighbour.clone()));
		neighbour[0]=degreeY-2;
		neighbour[1]=(2*degreeY-1);	
		addNeighbours(getVertex(degreeY-1),((int[])neighbour.clone()));
		neighbour[0]=(degreeX-2)*degreeY;
		neighbour[1]=(degreeX-1)*degreeY+1;
		addNeighbours(getVertex((degreeX-1)*degreeY),((int[])neighbour.clone()));	
		neighbour[0]=(degreeX-1)*degreeY-1;
		neighbour[1]=degreeX*degreeY-2;
		addNeighbours(getVertex(degreeX*degreeY-1),((int[])neighbour.clone()));		
		setColor(CoreConstant.DRAWBERZIE_COLOR);
		setType(CoreConstant.DRAWCANVAS_BERZIE);
	}
	
	public DrawBerzie(int unit,double z,int degreeX,int degreeY) {
	
		double[] point=new double[4];
		
		this.degreeX=degreeX;
		this.degreeY=degreeY;
		for(int i=0;i<degreeX;i++)
			for(int j=0;j<degreeY;j++) {
				point[0]=(-(double)(degreeX-1)/2+i)*unit;
				point[1]=(-(double)(degreeY-1)/2+j)*unit;
				point[2]=z;
				point[3]=1.0;
				vertex.add(new DrawElement(((double[])point.clone())));
			}
		int[] neighbour=new int[4];
		for(int i=1;i<degreeX-1;i++)
			for(int j=1;j<degreeY-1;j++) {
				neighbour[0]=degreeY*i+j-1;
				neighbour[1]=degreeY*i+j+1;
				neighbour[2]=degreeY*(i-1)+j;
				neighbour[3]=degreeY*(i+1)+j;
				addNeighbours(getVertex(degreeY*i+j),((int[])neighbour.clone()));
			}
		neighbour=new int[3];
		for(int i=1;i<degreeY-1;i++) {
				neighbour[0]=i-1;
				neighbour[1]=i+1;
				neighbour[2]=degreeY+i;
				addNeighbours(getVertex(i),((int[])neighbour.clone()));
		}
		for(int i=1;i<degreeY-1;i++) {
				neighbour[0]=degreeY*(degreeX-1)+i-1;
				neighbour[1]=degreeY*(degreeX-1)+i+1;
				neighbour[2]=degreeY*(degreeX-2)+i;
				addNeighbours(getVertex(degreeY*(degreeX-1)+i),((int[])neighbour.clone()));
		}
		for(int i=1;i<degreeX-1;i++) {
				neighbour[0]=(i-1)*degreeY;
				neighbour[1]=(i+1)*degreeY;;
				neighbour[2]=degreeY*i+1;
				addNeighbours(getVertex(i*degreeY),((int[])neighbour.clone()));
		}
		for(int i=1;i<degreeX-1;i++) {
				neighbour[0]=i*degreeY-1;
				neighbour[1]=(i+2)*degreeY-1;
				neighbour[2]=degreeY*(i+1)-2;
				addNeighbours(getVertex(degreeY*(i+1)-1),((int[])neighbour.clone()));
		}
		neighbour=new int[2];
		neighbour[0]=1;
		neighbour[1]=degreeY;
		addNeighbours(getVertex(0),((int[])neighbour.clone()));
		neighbour[0]=degreeY-2;
		neighbour[1]=(2*degreeY-1);	
		addNeighbours(getVertex(degreeY-1),((int[])neighbour.clone()));
		neighbour[0]=(degreeX-2)*degreeY;
		neighbour[1]=(degreeX-1)*degreeY+1;
		addNeighbours(getVertex((degreeX-1)*degreeY),((int[])neighbour.clone()));	
		neighbour[0]=(degreeX-1)*degreeY-1;
		neighbour[1]=degreeX*degreeY-2;
		addNeighbours(getVertex(degreeX*degreeY-1),((int[])neighbour.clone()));		
		setColor(CoreConstant.DRAWBERZIE_COLOR);
		setType(CoreConstant.DRAWCANVAS_BERZIE);
	}
	
	
	public int getDegreeX() {
	
		return degreeX;
	}

	public int getDegreeY() {
	
		return degreeY;
	}
	

	


//	returnValue=new double[3];
//	for(int k=0;k<3;k++) {
//		for(int i=0;i<degreeX;i++) 
//			for(int j=0;j<degreeY;j++) {
//				tmpPoint=getVertex(i*degreeY+j);
//		//		System.out.println("CP0: "+ tmpPoint[0] +"CP1: "+ tmpPoint[1] +"CP2: "+ tmpPoint[2]);
//				returnValue[k]=returnValue[k]+(tmpPoint[k]*Geometry.berstein(i,degreeX,u)*Geometry.berstein(j,degreeY,v));
//			}
//	}



}
















