import java.awt.Canvas;
import java.awt.Graphics;
import java.util.Vector;
import java.awt.Color;


public class DrawCanvas extends Canvas {

	Vector draw;
	int width,height;
	int type;
	int selected,modifier,drawCounter=-1;
	Color originalColor;

	
	public DrawCanvas(int width,int height,int type) {
	
		this.width=width;
		this.height=height;
		this.type=type;
		this.setBackground(Color.white);
		draw=new Vector(CoreConstant.DRAWCANVAS_INTICAP,CoreConstant.DRAWCANVAS_INCR);
	}
	


	public void paint(Graphics g) {

	double[] uv={0,width,0,height};
				
//			if (modifier==CoreConstant.DRAWCANVAS_HASMODIFIED){
//				System.out.println("--------------");
				drawCounter=-1;
				Engine.setUV(uv);
				draw=Engine.Pipeline(type);
//				drawCounter=Engine.selected;
//				System.out.println("drawCounter: " +drawCounter);
				for(int i=0;i<draw.size();i++)  {
//					if(i==Engine.selected)
					drawCounter=i;
					paintDraw(g,(Draw)draw.get(i));
				}
				paintBorder(g);	
//			}else {
//				for(int i=0;i<draw.size();i++)
//					paintDraw(g,(Draw)draw.get(i));
//				paintBorder(g);
//				modifier-=1;	
//			}
	}
	
	public void select(int[] position) {
	
		Draw tmpDraw;
	
		this.selected=-1;
		for(int i=CoreConstant.DRAWCANVAS_MAXRESERVED;i<draw.size();i++)
			if (selected==-1) {
				tmpDraw=(Draw)draw.get(i);
				if(tmpDraw.isReal){
					tmpDraw.makeOmogeneous();
					if (tmpDraw.checkDraw2D(position)) {
						this.selected=i;
//						System.out.println("sel: "+selected+" Color: "+ originalColor);
						modifier-=1;
					}
				}
			}
		Engine.select(selected);
	}
	
	
	public void selectVertex(int[] position) {
		
		Draw tmpDraw;
		double[] vertex;
		double length;
		int selectedVertex;
	
		this.selected=-1;
		selectedVertex=-1;
		for(int i=CoreConstant.DRAWCANVAS_MAXRESERVED;i<draw.size();i++) {
			tmpDraw=(Draw)draw.get(i);
			tmpDraw.makeOmogeneous();
			for(int j=0;j<tmpDraw.size();j++) {
				vertex=tmpDraw.getVertex(j);
				length=Math.sqrt((Math.pow(((double)position[0]-vertex[0]),2)+Math.pow(((double)position[1]-vertex[1]),2)));
				if (length<=CoreConstant.DRAWCANVAS_MAXDISTANCE) {
					selected=i;
					selectedVertex=j;
				}
			}
		}
		Engine.select(selected);
		Engine.selectVertex(selectedVertex);
//		System.out.println("vertex "+ selectedVertex);	
	}
	
	public void selectWeight(int[] position) {
		
		Draw tmpDraw;
		double[] vertex;
		double length;
		int selectedWeight;
	
		this.selected=-1;
		selectedWeight=-1;
		for(int i=CoreConstant.DRAWCANVAS_MAXRESERVED;i<draw.size();i++) {
			tmpDraw=(Draw)draw.get(i);
			tmpDraw.makeOmogeneous();
			for(int j=0;j<tmpDraw.size();j++) {
				vertex=tmpDraw.getVertex(j);
				length=Math.sqrt((Math.pow(((double)position[0]-vertex[0]),2)+Math.pow(((double)position[1]-vertex[1]),2)));
				if (length<=CoreConstant.DRAWCANVAS_MAXDISTANCE) {
					selected=i;
					selectedWeight=j;
				}
			}
		}
		Engine.select(selected);
		Engine.setSelectedWeight(selectedWeight);	
	}
	
	public void paintBorder(Graphics g) {
	
		g.setColor(CoreConstant.DRAWCANVAS_BORDERCOLOR);
		g.drawLine(0,0,0,height-1);
		g.drawLine(0,0,width-1,0);
		g.drawLine(width-1,0,width-1,height-1);
		g.drawLine(0,height-1,width-1,height-1);
	}
	
	public void paintaxis(Graphics g) {
	
	
	}
	
	public void paintDraw(Graphics g,Draw draw) {
		
	double[][] vertex,transformedVertex;
	int[] neighbour;
	String name=null;
		

		if (draw!=null) {
				vertex=draw.getVertex();
			transformedVertex=new double[vertex.length][];
			for(int i=0;i<transformedVertex.length;i++) {
				transformedVertex[i]=Geometry.makeOmogenous(vertex[i]); 
//				for(int j=0;j<transformedVertex[i].length;j++)
//					System.out.println(" " + transformedVertex[i][j]);
//				System.out.println("\n");
			}
//			System.out.println("type: "+draw.getType());
			g.setColor(draw.getColor());
			if(draw.getType()==CoreConstant.DRAWCANVAS_POLY)
				for(int i=0;i<transformedVertex.length;i++) {
					name=draw.getName(vertex[i]);
					if(name!=null)
						g.drawString(name,(int)(transformedVertex[i][0]+CoreConstant.DRAWCANVAS_NAMEX),(int)(height-transformedVertex[i][1]+CoreConstant.DRAWCANVAS_NAMEY));
					neighbour=draw.getNeighbours(vertex[i]);
					for(int j=0;j<neighbour.length;j++) {
						transform(g,(int)transformedVertex[i][0],(int)transformedVertex[i][1],(int)transformedVertex[neighbour[j]][0],(int)transformedVertex[neighbour[j]][1]);
	//					System.out.println("x1: "+(int)transformedVertex[i][0]+" y1: "+(int)transformedVertex[i][1]+" x2: "+(int)transformedVertex[neighbour[j]][0]+" y2: "+(int)transformedVertex[neighbour[j]][1]+" neigh: "+neighbour[j]);
					}
//					System.out.println("drawCounter: "+drawCounter +" i: "+ i+"  "+Engine.selected+"  "+Engine.selectedVertex);
					if (Engine.selected==drawCounter && Engine.selectedVertex==i) {
//						System.out.println("drawCounter: "+drawCounter +" i: "+ i+"  "+Engine.selected+"  "+Engine.selectedVertex);
						g.setColor(CoreConstant.ENGINE_SELECTEDCOLOR);
						g.drawOval((int)transformedVertex[i][0]-5,(int)(height-transformedVertex[i][1]-5),10,10);   //mettere in constant
						g.setColor(draw.getColor());
					}					
				}
			else if (draw.getType()==CoreConstant.DRAWCANVAS_BERZIE) {
				g.setColor(CoreConstant.DRAWBERZIE_HULLCOLOR);
				for(int i=0;i<transformedVertex.length;i++) {
					name=draw.getName(vertex[i]);
					if(name!=null)
						g.drawString(name,(int)(transformedVertex[i][0]+CoreConstant.DRAWCANVAS_NAMEX),(int)(height-transformedVertex[i][1]+CoreConstant.DRAWCANVAS_NAMEY));
					if (DrawPanel.hullCheckbox.getState()) {
						neighbour=draw.getNeighbours(vertex[i]);
						for(int j=0;j<neighbour.length;j++) {
							g.setColor(CoreConstant.DRAWBERZIE_HULLCOLOR);
							transform(g,(int)transformedVertex[i][0],(int)transformedVertex[i][1],(int)transformedVertex[neighbour[j]][0],(int)transformedVertex[neighbour[j]][1]);
	//						System.out.println("x1: "+(int)transformedVertex[i][0]+" y1: "+(int)transformedVertex[i][1]+" x2: "+(int)transformedVertex[neighbour[j]][0]+" y2: "+(int)transformedVertex[neighbour[j]][1]+" neigh: "+neighbour[j]);
						}
					}else  {
						g.setColor(CoreConstant.DRAWBERZIE_HULLCOLOR);
						g.drawOval((int)transformedVertex[i][0]-2,(int)(height-transformedVertex[i][1]-2),4,4);
						g.setColor(draw.getColor());
					}
			//		System.out.println("drawCounter: "+drawCounter +" i: "+ i+"  "+Engine.selected+"  "+Engine.selectedVertex);
					if (Engine.selected==drawCounter && Engine.selectedVertex==i) {
						g.setColor(CoreConstant.ENGINE_SELECTEDCOLOR);
						g.drawOval((int)transformedVertex[i][0]-5,(int)(height-transformedVertex[i][1]-5),10,10);   //mettere in constant
						g.setColor(draw.getColor());
					}					
				}
				g.setColor(draw.getColor());
				Geometry.setBerzieControlPoint(draw);
				double[][][] berziePoint=new double[CoreConstant.DRAWCANVAS_BERZIEUSECT][CoreConstant.DRAWCANVAS_BERZIEVSECT][];
				for(int u=0;u<CoreConstant.DRAWCANVAS_BERZIEUSECT;u++)
					for (int v=0;v<CoreConstant.DRAWCANVAS_BERZIEVSECT;v++) {
						berziePoint[u][v]=Geometry.getPointByTensor(((double)u/(CoreConstant.DRAWCANVAS_BERZIEUSECT-1)),(double)v/(CoreConstant.DRAWCANVAS_BERZIEVSECT-1));
						berziePoint[u][v]=Geometry.makeOmogenous(berziePoint[u][v]);
//						for(int k=0;k<berziePoint[u][v].length;k++)
//							System.out.print(" berzie " +k+": " +berziePoint[u][v][k]);
//						System.out.println();
//						System.out.println("u: "+(double)u/(CoreConstant.DRAWCANVAS_BERZIEUSECT-1)+" v: "+(double)v/(CoreConstant.DRAWCANVAS_BERZIEUSECT-1) );
					}
				for(int i=0;i<CoreConstant.DRAWCANVAS_BERZIEUSECT-1;i++)
					for(int j=0;j<CoreConstant.DRAWCANVAS_BERZIEVSECT-1;j++) {
						transform(g,(int)berziePoint[i][j][0],(int)berziePoint[i][j][1],(int)berziePoint[i+1][j][0],(int)berziePoint[i+1][j][1]);
						transform(g,(int)berziePoint[i][j][0],(int)berziePoint[i][j][1],(int)berziePoint[i][j+1][0],(int)berziePoint[i][j+1][1]);
				}
				for(int i=0;i<CoreConstant.DRAWCANVAS_BERZIEUSECT-1;i++)
					transform(g,(int)berziePoint[i][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][0],(int)berziePoint[i][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][1],(int)berziePoint[i+1][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][0],(int)berziePoint[i+1][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][1]);
				for(int j=0;j<CoreConstant.DRAWCANVAS_BERZIEVSECT-1;j++) 
						transform(g,(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][j][0],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][j][1],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][j+1][0],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][j+1][1]);
//				for (int i=0;i<CoreConstant.DRAWCANVAS_BERZIEUSECT-1;i++)
//					transform(g,(int)berziePoint[i][CoreConstant.DRAWCANVAS_BERZIEUSECT-1][0],(int)berziePoint[i][CoreConstant.DRAWCANVAS_BERZIEUSECT-1][1],(int)berziePoint[i+1][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][1],(int)berziePoint[i+1][CoreConstant.DRAWCANVAS_BERZIEUSECT-1][1]);
//				for (int i=0;i<CoreConstant.DRAWCANVAS_BERZIEVSECT-1;i++)
//					transform(g,(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][i][0],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][i][1],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][i+1][1],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][i+1][1]);
//				for (int i=0;i<transformedVertex.length;i++) 
//					System.out.println("position: "+i+ " point[0]: " + transformedVertex[i][0] +" point[1]: " + transformedVertex[i][1] +" point[2]: " + transformedVertex[i][2]);
//				for (int i=0;i<CoreConstant.DRAWCANVAS_BERZIEUSECT;i++) 
//					for (int j=0;j<CoreConstant.DRAWCANVAS_BERZIEVSECT;j++)

			}	else if (draw.getType()==CoreConstant.DRAWCANVAS_RATIONAL) {
				g.setColor(CoreConstant.DRAWBERZIE_HULLCOLOR);
				for(int i=0;i<transformedVertex.length;i++) {
					name=draw.getName(vertex[i]);
					if(name!=null)
						g.drawString(name,(int)(height-transformedVertex[i][0]+CoreConstant.DRAWCANVAS_NAMEX),(int)(transformedVertex[i][1]+CoreConstant.DRAWCANVAS_NAMEY));
					if (DrawPanel.hullCheckbox.getState()) {
						neighbour=draw.getNeighbours(vertex[i]);
						for(int j=0;j<neighbour.length;j++) {
							g.setColor(CoreConstant.DRAWBERZIE_HULLCOLOR);
							transform(g,(int)transformedVertex[i][0],(int)transformedVertex[i][1],(int)transformedVertex[neighbour[j]][0],(int)transformedVertex[neighbour[j]][1]);
	//						System.out.println("x1: "+(int)transformedVertex[i][0]+" y1: "+(int)transformedVertex[i][1]+" x2: "+(int)transformedVertex[neighbour[j]][0]+" y2: "+(int)transformedVertex[neighbour[j]][1]+" neigh: "+neighbour[j]);
						}
					}else  {
						g.setColor(CoreConstant.DRAWBERZIE_HULLCOLOR);
						g.drawOval((int)transformedVertex[i][0]-2,(int)(height-transformedVertex[i][1]-2),4,4);
					}
			//		System.out.println("drawCounter: "+drawCounter +" i: "+ i+"  "+Engine.selected+"  "+Engine.selectedVertex);
					if (Engine.selected==drawCounter && Engine.selectedVertex==i) {
						g.setColor(CoreConstant.ENGINE_SELECTEDCOLOR);
						g.drawOval((int)transformedVertex[i][0]-5,(int)(height-transformedVertex[i][1]-5),10,10);   //mettere in constant
						g.setColor(draw.getColor());
					}
					if (Engine.selected==drawCounter && Engine.selectedWeight==i) {
						g.setColor(CoreConstant.ENGINE_SELECTEDCOLOR);
						g.drawRect((int)transformedVertex[i][0]-5,(int)(height-transformedVertex[i][1]-5),10,10);   //mettere in constant
						g.setColor(draw.getColor());
					}
				}
				g.setColor(draw.getColor());
				Geometry.setRationalBerzieControlPoint(draw);
				double[][][] berziePoint=new double[CoreConstant.DRAWCANVAS_BERZIEUSECT][CoreConstant.DRAWCANVAS_BERZIEVSECT][];
				for(int u=0;u<CoreConstant.DRAWCANVAS_BERZIEUSECT;u++)
					for (int v=0;v<CoreConstant.DRAWCANVAS_BERZIEVSECT;v++) {
						berziePoint[u][v]=Geometry.getRationalPointByTensor(((double)u/(CoreConstant.DRAWCANVAS_BERZIEUSECT-1)),(double)v/(CoreConstant.DRAWCANVAS_BERZIEVSECT-1));
						berziePoint[u][v]=Geometry.makeOmogenous(berziePoint[u][v]);
//						for(int k=0;k<berziePoint[u][v].length;k++)
//							System.out.print(" berzie " +k+": " +berziePoint[u][v][k]);
//						System.out.println();
//						System.out.println("u: "+(double)u/(CoreConstant.DRAWCANVAS_BERZIEUSECT-1)+" v: "+(double)v/(CoreConstant.DRAWCANVAS_BERZIEUSECT-1) );
					}
				for(int i=0;i<CoreConstant.DRAWCANVAS_BERZIEUSECT-1;i++)
					for(int j=0;j<CoreConstant.DRAWCANVAS_BERZIEVSECT-1;j++) {
						transform(g,(int)berziePoint[i][j][0],(int)berziePoint[i][j][1],(int)berziePoint[i+1][j][0],(int)berziePoint[i+1][j][1]);
						transform(g,(int)berziePoint[i][j][0],(int)berziePoint[i][j][1],(int)berziePoint[i][j+1][0],(int)berziePoint[i][j+1][1]);
				}
				for(int i=0;i<CoreConstant.DRAWCANVAS_BERZIEUSECT-1;i++)
					transform(g,(int)berziePoint[i][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][0],(int)berziePoint[i][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][1],(int)berziePoint[i+1][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][0],(int)berziePoint[i+1][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][1]);
				for(int j=0;j<CoreConstant.DRAWCANVAS_BERZIEVSECT-1;j++) 
						transform(g,(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][j][0],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][j][1],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][j+1][0],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][j+1][1]);
//				for (int i=0;i<CoreConstant.DRAWCANVAS_BERZIEUSECT-1;i++)
//					transform(g,(int)berziePoint[i][CoreConstant.DRAWCANVAS_BERZIEUSECT-1][0],(int)berziePoint[i][CoreConstant.DRAWCANVAS_BERZIEUSECT-1][1],(int)berziePoint[i+1][CoreConstant.DRAWCANVAS_BERZIEVSECT-1][1],(int)berziePoint[i+1][CoreConstant.DRAWCANVAS_BERZIEUSECT-1][1]);
//				for (int i=0;i<CoreConstant.DRAWCANVAS_BERZIEVSECT-1;i++)
//					transform(g,(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][i][0],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][i][1],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][i+1][1],(int)berziePoint[CoreConstant.DRAWCANVAS_BERZIEUSECT-1][i+1][1]);
//				for (int i=0;i<transformedVertex.length;i++) 
//					System.out.println("position: "+i+ " point[0]: " + transformedVertex[i][0] +" point[1]: " + transformedVertex[i][1] +" point[2]: " + transformedVertex[i][2]);
//				for (int i=0;i<CoreConstant.DRAWCANVAS_BERZIEUSECT;i++) 
//					for (int j=0;j<CoreConstant.DRAWCANVAS_BERZIEVSECT;j++)
//						System.out.println("u: " +i + " v: "+j+"berzie[0]: "+berziePoint[i][j][0]+" berzie[1]: "+berziePoint[i][j][1]+" berzie[2]: "+berziePoint[i][j][2]);
//				System.out.println("weights: " +((DrawRationalBerzie)draw).getWeights());
			}

		}
	}

	public int getType() {
	
		return type;
	}

	public void setType(int type) {
	
		this.type=type;
	}
	
	public int getModifier () {
	
		return modifier;
	}
	
	public void setModifier(int modifier) {
	
		this.modifier=modifier;
	}
	
	protected void transform(Graphics g,int x1,int y1,int x2,int y2) {
		
		g.drawLine(x1,height-y1,x2,height-y2);
	}
}