import java.awt.Frame;
import java.awt.Panel;
import java.awt.Font;
import java.awt.Color;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;

public class DrawFrame extends Frame {

static Frame draw;
static Font font;
static Color background,foreground;
static DrawPanel panel;
static MenuBar drawMenuBar;
static Menu selectMenu;
static Menu createMenu;
static Menu modifyMenu;
static Menu helpMenu;
static Menu optionMenu;
static DrawFrameAdapter drawFrameAdapter;
static MenuItem menuItemCube,menuItemSphere,menuItemBerzie,menuItemRationalBerzie,menuItemTranslate,menuItemRotate,menuItemScale,menuItemSetColor,menuItemByObject,menuItemByVertex,menuItemByWeight,menuItemSpanU,menuItemSpanV,menuItemTopDistance,menuItemSideDistance,menuItemFrontDistance,menuItemEyeDistance,menuItemPlaneDistance;
static int menunum=13;

	public DrawFrame(int type,Color foreground,Color background,Font font) {

		this.font=font;
		this.background=background;
		this.foreground=foreground;

		drawMenuBar=new MenuBar();
		drawFrameAdapter=new DrawFrameAdapter();

		createMenu=new Menu(Constant.DRAWPANEL_CREATE);
		modifyMenu=new Menu(Constant.DRAWFRAME_MODIFY);
		selectMenu=new Menu(Constant.DRAWFRAME_SELECT);
		optionMenu=new Menu(Constant.DRAWFRAME_OPTION);
		
		
		
		menuItemCube=new MenuItem(Constant.DRAWPANEL_CUBE);
		menuItemCube.setActionCommand(Constant.DRAWPANEL_CUBE);
		menuItemCube.addActionListener(drawFrameAdapter);
		createMenu.add(menuItemCube);
		
		menuItemSphere=new MenuItem(Constant.DRAWPANEL_SPHERE);
		menuItemSphere.setActionCommand(Constant.DRAWPANEL_SPHERE);
		menuItemSphere.addActionListener(drawFrameAdapter);
		createMenu.add(menuItemSphere);
		
		menuItemBerzie=new MenuItem(Constant.DRAWPANEL_BERZIE);
		menuItemBerzie.setActionCommand(Constant.DRAWPANEL_BERZIE);
		menuItemBerzie.addActionListener(drawFrameAdapter);
		createMenu.add(menuItemBerzie);
		
		menuItemRationalBerzie=new MenuItem(Constant.DRAWPANEL_RATIONALBERZIE);
		menuItemRationalBerzie.setActionCommand(Constant.DRAWPANEL_RATIONALBERZIE);
		menuItemRationalBerzie.addActionListener(drawFrameAdapter);
		createMenu.add(menuItemRationalBerzie);
		
		
		menuItemTranslate=new MenuItem(Constant.DRAWFRAME_TRANSLATE);
		menuItemTranslate.setActionCommand(Constant.DRAWFRAME_TRANSLATE);
		menuItemTranslate.addActionListener(drawFrameAdapter);
		modifyMenu.add(menuItemTranslate);
						
		menuItemRotate=new MenuItem(Constant.DRAWFRAME_ROTATE);
		menuItemRotate.setActionCommand(Constant.DRAWFRAME_ROTATE);
		menuItemRotate.addActionListener(drawFrameAdapter);
		modifyMenu.add(menuItemRotate);
		
		menuItemScale=new MenuItem(Constant.DRAWFRAME_SCALE);
		menuItemScale.setActionCommand(Constant.DRAWFRAME_SCALE);
		menuItemScale.addActionListener(drawFrameAdapter);
		modifyMenu.add(menuItemScale);
		
		menuItemSetColor=new MenuItem(Constant.DRAWFRAME_SETCOLOR);
		menuItemSetColor.setActionCommand(Constant.DRAWFRAME_SETCOLOR);
		menuItemSetColor.addActionListener(drawFrameAdapter);
		modifyMenu.add(menuItemSetColor);
		
		
		menuItemByObject=new MenuItem(Constant.DRAWPANEL_BYOBJECT);
		menuItemByObject.setActionCommand(Constant.DRAWPANEL_BYOBJECT);
		menuItemByObject.addActionListener(drawFrameAdapter);
		selectMenu.add(menuItemByObject);

		menuItemByVertex=new MenuItem(Constant.DRAWPANEL_BYVERTEX);
		menuItemByVertex.setActionCommand(Constant.DRAWPANEL_BYVERTEX);
		menuItemByVertex.addActionListener(drawFrameAdapter);
		selectMenu.add(menuItemByVertex);
		
		menuItemByWeight=new MenuItem(Constant.DRAWPANEL_BYWEIGHT);
		menuItemByWeight.setActionCommand(Constant.DRAWPANEL_BYWEIGHT);
		menuItemByWeight.addActionListener(drawFrameAdapter);
		selectMenu.add(menuItemByWeight);
		
	
		menuItemSpanU=new MenuItem(Constant.DRAWFRAME_SPANU);
		menuItemSpanU.setActionCommand(Constant.DRAWFRAME_SPANU);
		menuItemSpanU.addActionListener(drawFrameAdapter);
		optionMenu.add(menuItemSpanU);

		menuItemSpanV=new MenuItem(Constant.DRAWFRAME_SPANV);
		menuItemSpanV.setActionCommand(Constant.DRAWFRAME_SPANV);
		menuItemSpanV.addActionListener(drawFrameAdapter);
		optionMenu.add(menuItemSpanV);
		
		menuItemTopDistance=new MenuItem(Constant.DRAWFRAME_TOPDISTANCE);
		menuItemTopDistance.setActionCommand(Constant.DRAWFRAME_TOPDISTANCE);
		menuItemTopDistance.addActionListener(drawFrameAdapter);
		optionMenu.add(menuItemTopDistance);

		menuItemSideDistance=new MenuItem(Constant.DRAWFRAME_SIDEDISTANCE);
		menuItemSideDistance.setActionCommand(Constant.DRAWFRAME_SIDEDISTANCE);
		menuItemSideDistance.addActionListener(drawFrameAdapter);
		optionMenu.add(menuItemSideDistance);
		
		menuItemFrontDistance=new MenuItem(Constant.DRAWFRAME_FRONTDISTANCE);
		menuItemFrontDistance.setActionCommand(Constant.DRAWFRAME_FRONTDISTANCE);
		menuItemFrontDistance.addActionListener(drawFrameAdapter);
		optionMenu.add(menuItemFrontDistance);

		menuItemEyeDistance=new MenuItem(Constant.DRAWFRAME_EYEDISTANCE);
		menuItemEyeDistance.setActionCommand(Constant.DRAWFRAME_EYEDISTANCE);
		menuItemEyeDistance.addActionListener(drawFrameAdapter);
		optionMenu.add(menuItemEyeDistance);

		menuItemPlaneDistance=new MenuItem(Constant.DRAWFRAME_PLANEDISTANCE);
		menuItemPlaneDistance.setActionCommand(Constant.DRAWFRAME_PLANEDISTANCE);
		menuItemPlaneDistance.addActionListener(drawFrameAdapter);
		optionMenu.add(menuItemPlaneDistance);

		drawMenuBar.add(createMenu);
		drawMenuBar.add(modifyMenu);
		drawMenuBar.add(selectMenu);
		drawMenuBar.add(optionMenu);
				
		draw=new Frame("Draw");
		panel=new DrawPanel(type,foreground,background,font);
		draw.add(panel);
		draw.setMenuBar(drawMenuBar);
		draw.pack ();
		draw.setVisible(true);
		draw.addWindowListener(new DrawListener());

	}
	
	public static void on() {
	
		draw.setVisible(true);
	}
	
	public static void off() {
	
		draw.setVisible(false);
	}
	
//	public void setEye(double[] eye) {
//	
//		panel.setEye(eye);
//	}
//
//	public void addDraw(Draw draw) {
//	
//		panel.addDraw(draw);
//	}
//
//	public void setDistance(double distance) {
//	
//		panel.setDistance(distance);
//	}
	
	public static void setMenu(boolean[] menu) {
		
		menuItemCube.setEnabled(menu[0]);
		menuItemSphere.setEnabled(menu[1]);
		menuItemBerzie.setEnabled(menu[2]);
		menuItemRationalBerzie.setEnabled(menu[3]);
		menuItemTranslate.setEnabled(menu[4]);
		menuItemRotate.setEnabled(menu[5]);
		menuItemScale.setEnabled(menu[6]);
		menuItemSetColor.setEnabled(menu[7]);
		menuItemByObject.setEnabled(menu[8]);
		menuItemByVertex.setEnabled(menu[9]);
		menuItemByWeight.setEnabled(menu[10]);
		menuItemSpanU.setEnabled(menu[11]);
		menuItemSpanV.setEnabled(menu[12]);
	}

	public static void redraw() {
		panel.reDraw();
	}

}