import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.event.MouseMotionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Choice;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

public class DrawListener implements MouseMotionListener, WindowListener, KeyListener, MouseListener ,ActionListener,ItemListener{

boolean[] modifiers=new boolean[3];
DrawCanvas[] canvas;

	public DrawListener(DrawCanvas[] canvas) {
	
		this.canvas=canvas;
	}
	
	public DrawListener(){
	}
	
	public void keyTyped(KeyEvent evt) {

	}

	public void keyPressed(KeyEvent evt) {
		int typed;

		typed=evt.getKeyCode();
		if (typed==KeyEvent.VK_ALT) {
			modifiers[0]=true;
		}else if (typed==KeyEvent.VK_CONTROL) {
			modifiers[1]=true;
		}else if (typed==KeyEvent.VK_SHIFT) {
			modifiers[2]=true;
		}
	}

	public void keyReleased(KeyEvent evt) {
		int typed;
		
		typed=evt.getKeyCode();
		if (typed==KeyEvent.VK_ALT) {
			modifiers[0]=false;
		}else if (typed==KeyEvent.VK_CONTROL) {
			modifiers[1]=false;
		}else if (typed==KeyEvent.VK_SHIFT) {
			modifiers[2]=false;
		}
	}

	/**********
	** MOUSE **
	**********/
	
	int x,y,distanceX,distanceY;
	double[] modifier;
	DrawCanvas tmpCanvas=null;

	public void mouseClicked(MouseEvent evt) {

	int[] xy=new int[2];
	DrawCanvas tmpCanvas=null;
	

//		System.out.println("click\n");
		if (DrawPanel.objectCheckbox.getState()) {
			xy[0]=evt.getX();
			xy[1]=Constant.DRAWCANVAS_HEIGHT-evt.getY();
			for(int i=0;i<canvas.length;i++)
				if(canvas[i]==(DrawCanvas)evt.getSource())
					tmpCanvas=canvas[i];
			tmpCanvas.select(xy);
			for(int i=0;i<canvas.length;i++)
				canvas[i].repaint();
		}else if(DrawPanel.vertexCheckbox.getState()) {
			xy[0]=evt.getX();
			xy[1]=Constant.DRAWCANVAS_HEIGHT-evt.getY();
			for(int i=0;i<canvas.length;i++)
				if(canvas[i]==(DrawCanvas)evt.getSource())
					tmpCanvas=canvas[i];
			tmpCanvas.selectVertex(xy);
			for(int i=0;i<canvas.length;i++)
				canvas[i].repaint();
		}else if(DrawPanel.weightsCheckbox.getState()) {
			xy[0]=evt.getX();
			xy[1]=Constant.DRAWCANVAS_HEIGHT-evt.getY();
			for(int i=0;i<canvas.length;i++)
				if(canvas[i]==(DrawCanvas)evt.getSource())
					tmpCanvas=canvas[i];
			tmpCanvas.selectWeight(xy);
			for(int i=0;i<canvas.length;i++)
				canvas[i].repaint();
//		System.out.println("click\n");
		}
	}

	public void mousePressed(MouseEvent evt) {

//		System.out.println("sett\n");
		this.x=evt.getX();
		this.y=evt.getY();
	}

	public void mouseReleased(MouseEvent evt) {
	}

	public void mouseEntered(MouseEvent evt) {
	}

	public void mouseExited(MouseEvent evt) {
	}
	
	public void mouseDragged(MouseEvent evt) {
	int x,y;

		x=evt.getX();
		y=evt.getY();
		distanceX=x-this.x;
		distanceY=y-this.y;
		this.y=y;
		this.x=x;		
		for(int i=0;i<canvas.length;i++)
			if(canvas[i]==(DrawCanvas)evt.getSource())
				tmpCanvas=canvas[i];
				
				
		if (tmpCanvas.getType()==CoreConstant.ENGINE_EYE)  {
			draggedEye(evt);			
		}else if (tmpCanvas.getType()==CoreConstant.ENGINE_TOP)  {			
			draggedTop(evt);
		}else if (tmpCanvas.getType()==CoreConstant.ENGINE_FRONT)  {
			draggedFront(evt);			
		}else if (tmpCanvas.getType()==CoreConstant.ENGINE_SIDE)  {
			draggedSide(evt);			
		}
	}
	
	public void mouseMoved(MouseEvent evt) {
	}

	/***********
	** WINDOW **
	***********/

	public void windowOpened(WindowEvent evt) {
	}

	public void windowClosed(WindowEvent evt) {
	}

	public void windowClosing(WindowEvent evt) {

		DrawFrame.off();
	}

	public void windowIconified(WindowEvent evt) {
	}

	public void windowDeiconified(WindowEvent evt) {
	}

	public void windowActivated(WindowEvent evt) {
	}

	public void windowDeactivated(WindowEvent evt) {
	}
	
	//////
	//Action
	////
	
	public void actionPerformed(ActionEvent evt) {
	Object source=evt.getSource();
		if(source==DrawPanel.create) {
			if(DrawPanel.objectChoice.getSelectedItem()==CoreConstant.DRAWPANEL_CUBE)
				Engine.addDraw(new DrawCube());
			if(DrawPanel.objectChoice.getSelectedItem()==CoreConstant.DRAWPANEL_SPHERE)
				Engine.addDraw(new DrawSphere());
			if(DrawPanel.objectChoice.getSelectedItem()==CoreConstant.DRAWPANEL_BERZIE)
				Engine.addDraw(new DrawBerzie(3,3));
			if(DrawPanel.objectChoice.getSelectedItem()==Constant.DRAWPANEL_RATIONALBERZIE)
				Engine.addDraw(new DrawRationalBerzie(3,3));
			for(int i=0;i<canvas.length;i++)  {
				canvas[i].setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
				canvas[i].repaint();
			}	
		}else if(source==DrawPanel.delete)  {
			Engine.removeSelected();
			for(int i=0;i<canvas.length;i++)
				canvas[i].repaint();
		}else if(source==DrawPanel.check) {
			if(DrawPanel.checkChoice.getSelectedItem()==Constant.DRAWPANEL_CHECKSPHERE)
				CollisionEngine.setType(CoreConstant.COLLISIONENGINE_BOUNDINGSPHERE);
			else if(DrawPanel.checkChoice.getSelectedItem()==Constant.DRAWPANEL_CHECKCUBE)
				CollisionEngine.setType(CoreConstant.COLLISIONENGINE_BOUNDINGBOX);
			else if(DrawPanel.checkChoice.getSelectedItem()==Constant.DRAWPANEL_CHECKANALITYC)
				CollisionEngine.setType(CoreConstant.COLLISIONENGINE_ANALITYC);
			Engine.checkCollision();
			DrawFrame.redraw();
		}			
	}
	
	
	public void draggedTop(MouseEvent evt) {


		
		if(evt.isShiftDown()) {
			modifier=new double[1];
			modifier[0]=Engine.getTopDistance();
			modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
			Engine.setTopDistance(modifier[0]);
//			for(int i=0;i<modifier.length;i++)
//				System.out.println(modifier[i]+" ");
//			System.out.println("\n ");
			tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
				tmpCanvas.repaint();
		}else if(DrawPanel.objectCheckbox .getState()) {
			if (DrawPanel.tCheckbox.getState()) {
				modifier=Engine.getDrawTranslate();
				if (modifier!=null) {
					modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
					modifier[1]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawTranslate(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}else if (DrawPanel.rCheckbox.getState()) {
				modifier=Engine.getDrawRotate();
				if (modifier!=null) {
					modifier[2]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
	//						modifier[1]+=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawRotate(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}else if (DrawPanel.sCheckbox.getState()) {
				modifier=Engine.getDrawScale();
				if (modifier!=null) {
					modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
					modifier[1]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawScale(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}
		}else if(DrawPanel.vertexCheckbox.getState()) {
			modifier=Engine.getSelectedVertex();
			if (modifier!=null) {
				modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
				modifier[1]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
				Engine.setSelectedVertex(modifier);
	//			for(int i=0;i<modifier.length;i++)
	//				System.out.println(modifier[i]+" ");
	//			System.out.println("\n ");
				tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
				for(int i=0;i<canvas.length;i++)
					canvas[i].repaint();
			}
		}else if (DrawPanel.weightsCheckbox.getState()) {
			modifier=new double[1];
			modifier[0]=Engine.getWeight();
			modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
//			modifier[1]+=distanceY*CoreConstant.DRAWADAPTER_SCALE;
			Engine.setWeight(modifier[0]);
//			for(int i=0;i<modifier.length;i++)
//				System.out.println(modifier[i]+" ");
//			System.out.println("\n ");
			tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
			for(int i=0;i<canvas.length;i++)
				canvas[i].repaint();
		}
	}

		
	public void draggedSide(MouseEvent evt) {
	
		if(evt.isShiftDown()) {
			modifier=new double[1];
			modifier[0]=Engine.getSideDistance();
			modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
			Engine.setSideDistance(modifier[0]);
//			for(int i=0;i<modifier.length;i++)
//				System.out.println(modifier[i]+" ");
//			System.out.println("\n ");
			tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
			tmpCanvas.repaint();
		}else  if(DrawPanel.objectCheckbox .getState()) {
			if (DrawPanel.tCheckbox.getState()) {
				modifier=Engine.getDrawTranslate();
				if (modifier!=null) {
					modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
					modifier[2]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawTranslate(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}else if (DrawPanel.rCheckbox.getState()) {
				modifier=Engine.getDrawRotate();
				if (modifier!=null) {
					modifier[1]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
	//						modifier[2]+=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawRotate(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}else if (DrawPanel.sCheckbox.getState()) {
				modifier=Engine.getDrawScale();
				if (modifier!=null) {
					modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
					modifier[2]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawScale(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}
		}else if(DrawPanel.vertexCheckbox.getState()) {
			modifier=Engine.getSelectedVertex();
			if (modifier!=null) {
				modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
				modifier[2]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
				Engine.setSelectedVertex(modifier);
	//			for(int i=0;i<modifier.length;i++)
	//				System.out.println(modifier[i]+" ");
	//			System.out.println("\n ");
				tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
				for(int i=0;i<canvas.length;i++)
					canvas[i].repaint();
			}
		}else if (DrawPanel.weightsCheckbox.getState()) {
			modifier=new double[1];
			modifier[0]=Engine.getWeight();
			modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
//			modifier[1]+=distanceY*CoreConstant.DRAWADAPTER_SCALE;
			Engine.setWeight(modifier[0]);
//			for(int i=0;i<modifier.length;i++)
//				System.out.println(modifier[i]+" ");
//			System.out.println("\n ");
			tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
			for(int i=0;i<canvas.length;i++)
				canvas[i].repaint();
		}
	}
		
	private void draggedFront(MouseEvent evt) {
	
		if(evt.isShiftDown()) {
				modifier=new double[1];
				modifier[0]=Engine.getFrontDistance();
				modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
				Engine.setFrontDistance(modifier[0]);
	//			for(int i=0;i<modifier.length;i++)
	//				System.out.println(modifier[i]+" ");
	//			System.out.println("\n ");
				tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
				tmpCanvas.repaint();
		}else if(DrawPanel.objectCheckbox .getState()) {
			if (DrawPanel.tCheckbox.getState()) {
				modifier=Engine.getDrawTranslate();
				if (modifier!=null) {
					modifier[1]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
					modifier[2]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawTranslate(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}else if (DrawPanel.rCheckbox.getState()) {
				modifier=Engine.getDrawRotate();
				if (modifier!=null) {
					modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
//						modifier[2]+=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawRotate(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}else if (DrawPanel.sCheckbox.getState()) {
				modifier=Engine.getDrawScale();
				if (modifier!=null) {
					modifier[1]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
					modifier[2]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
					Engine.setDrawScale(modifier);
		//			for(int i=0;i<modifier.length;i++)
		//				System.out.println(modifier[i]+" ");
		//			System.out.println("\n ");
					tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
					for(int i=0;i<canvas.length;i++)
						canvas[i].repaint();
				}
			}
		}else if(DrawPanel.vertexCheckbox.getState()) {
			modifier=Engine.getSelectedVertex();
			if (modifier!=null) {
				modifier[1]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
				modifier[2]-=distanceY*CoreConstant.DRAWADAPTER_SCALE;
				Engine.setSelectedVertex(modifier);
	//			for(int i=0;i<modifier.length;i++)
	//				System.out.println(modifier[i]+" ");
	//			System.out.println("\n ");
				tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
				for(int i=0;i<canvas.length;i++)
					canvas[i].repaint();
			}
		}else if (DrawPanel.weightsCheckbox.getState()) {
			modifier=new double[1];
			modifier[0]=Engine.getWeight();
			modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
//			modifier[1]+=distanceY*CoreConstant.DRAWADAPTER_SCALE;
			Engine.setWeight(modifier[0]);
//			for(int i=0;i<modifier.length;i++)
//				System.out.println(modifier[i]+" ");
//			System.out.println("\n ");
			tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
			for(int i=0;i<canvas.length;i++)
				canvas[i].repaint();
		}
	}
	
	private void draggedEye(MouseEvent evt) {
		
		if (evt.isAltDown()){
				modifier=Engine.getEye();
				modifier[1]+=distanceX*CoreConstant.DRAWADAPTER_ROTATEX;
				modifier[2]+=distanceY*CoreConstant.DRAWADAPTER_ROTATEY;
				Engine.setEye(modifier);
				tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
				tmpCanvas.repaint();
	//			for(int i=0;i<modifier.length;i++)
	//				System.out.println(modifier[i]+" ");
	//			System.out.println("\n ");
			}else if(evt.isControlDown()) {
	/*			modifier=canvas.getOrigin();
				modifier[0]+=distanceX;
				modifier[]+=distanceY;
				canvas.setorigin(modifier);*/
			}else if(evt.isShiftDown()) {
				modifier=new double[1];
				modifier[0]=Engine.getDistance();
				modifier[0]+=distanceX*CoreConstant.DRAWADAPTER_SCALE;
				Engine.setDistance(modifier[0]);
	//			for(int i=0;i<modifier.length;i++)
	//				System.out.println(modifier[i]+" ");
	//			System.out.println("\n ");
				tmpCanvas.setModifier(CoreConstant.DRAWCANVAS_HASMODIFIED);
				tmpCanvas.repaint();
			}
	}
	
	public void itemStateChanged(ItemEvent evt) {
		
	Object source=evt.getSource();
		
		if(source==DrawPanel.vertexCheckbox) {
			Engine.select(-1);
			Engine.selectVertex(-1);
			Engine.setSelectedWeight(-1);
			boolean[] menu=new boolean[DrawFrame.menunum];
			menu[0]=true;
			menu[1]=true;
			menu[2]=true;
			menu[3]=true;
			menu[4]=true;
			menu[5]=false;
			menu[6]=false;
			menu[7]=true;
			menu[8]=true;
			menu[9]=true;
			menu[10]=true;
			menu[11]=true;
			menu[12]=true;
			DrawFrame.setMenu(menu);
		}else if(source==DrawPanel.objectCheckbox) {
			Engine.select(-1);
			Engine.selectVertex(-1);
			Engine.setSelectedWeight(-1);
			boolean[] menu=new boolean[DrawFrame.menunum];
			menu[0]=true;
			menu[1]=true;
			menu[2]=true;
			menu[3]=true;
			menu[4]=true;
			menu[5]=true;
			menu[6]=true;
			menu[7]=true;
			menu[8]=true;
			menu[9]=true;
			menu[10]=true;
			menu[11]=true;
			menu[12]=true;
			DrawFrame.setMenu(menu);
		}else if(source==DrawPanel.weightsCheckbox) {
			Engine.select(-1);
			Engine.selectVertex(-1);
			Engine.setSelectedWeight(-1);
			boolean[] menu=new boolean[DrawFrame.menunum];
			menu[0]=true;
			menu[1]=true;
			menu[2]=true;
			menu[3]=true;
			menu[4]=true;
			menu[5]=false;
			menu[6]=false;
			menu[7]=true;
			menu[8]=true;
			menu[9]=true;
			menu[10]=true;
			menu[11]=true;
			menu[12]=true;
			DrawFrame.setMenu(menu);
		}else if(source==DrawPanel.hullCheckbox)
			DrawFrame.redraw();
	}
}
                                                                                                                                                                                                                                                                                                      