import java.awt.Panel;
import java.awt.Color;
import java.awt.Font;
import java.awt.Label;
import java.awt.Menu;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Choice;
import java.awt.Menu;
import java.awt.Button;
import java.awt.FlowLayout;


public class DrawPanel extends Panel {

	DrawListener drawListener;
	Font font;
	Color background,foreground;
	int type;
	DrawCanvas eyeCanvas,topCanvas,sideCanvas,frontCanvas;
	DrawCanvas[] canvas=new DrawCanvas[4];
	Panel leftPanel,rightPanel,centralPanel,buttonPanel;
	Label selectionLabel,modifyLabel,optionLabel,objectLabel,scaleLabel,rotateLabel,translateLabel;
	static Button create,delete,check; 
	static Checkbox rCheckbox,sCheckbox,tCheckbox,vertexCheckbox,objectCheckbox,weightsCheckbox,hullCheckbox;
	static CheckboxGroup srtCheckboxGroup,voCheckboxGroup;
	static Choice objectChoice,checkChoice;

	
	
	public DrawPanel(int type,Color foreground,Color background,Font font) {
	
		this.type=type;
		this.font=font;
		this.background=background;
		this.foreground=foreground;
	
		eyeCanvas=new DrawCanvas(Constant.DRAWCANVAS_HEIGHT,Constant.DRAWCANVAS_WIDTH,CoreConstant.ENGINE_EYE);
		eyeCanvas.setSize(Constant.DRAWCANVAS_HEIGHT,Constant.DRAWCANVAS_WIDTH);

		topCanvas=new DrawCanvas(Constant.DRAWCANVAS_HEIGHT,Constant.DRAWCANVAS_WIDTH,CoreConstant.ENGINE_TOP);
		topCanvas.setSize(Constant.DRAWCANVAS_HEIGHT,Constant.DRAWCANVAS_WIDTH);
		
		sideCanvas=new DrawCanvas(Constant.DRAWCANVAS_HEIGHT,Constant.DRAWCANVAS_WIDTH,CoreConstant.ENGINE_SIDE);
		sideCanvas.setSize(Constant.DRAWCANVAS_HEIGHT,Constant.DRAWCANVAS_WIDTH);
		
		frontCanvas=new DrawCanvas(Constant.DRAWCANVAS_HEIGHT,Constant.DRAWCANVAS_WIDTH,CoreConstant.ENGINE_FRONT);
		frontCanvas.setSize(Constant.DRAWCANVAS_HEIGHT,Constant.DRAWCANVAS_WIDTH);
		
		canvas[0]=topCanvas;
		canvas[1]=eyeCanvas;
		canvas[2]=sideCanvas;
		canvas[3]=frontCanvas;
		drawListener=new DrawListener(canvas);
		
		frontCanvas.addMouseListener(drawListener);
		frontCanvas.addMouseMotionListener(drawListener);
		frontCanvas.addKeyListener(drawListener);

		sideCanvas.addMouseListener(drawListener);
		sideCanvas.addMouseMotionListener(drawListener);
		sideCanvas.addKeyListener(drawListener);
												
		topCanvas.addMouseListener(drawListener);
		topCanvas.addMouseMotionListener(drawListener);
		topCanvas.addKeyListener(drawListener);	

		eyeCanvas.addMouseListener(drawListener);
		eyeCanvas.addMouseMotionListener(drawListener);
		eyeCanvas.addKeyListener(drawListener);
		
		centralPanel=new Panel();
		centralPanel.setLayout(new GridLayout(2,2));
		
//		xLabel=new Label();
//		xLabel.setForeground(foreground);
//		xLabel.setBackground(background);
//		xLabel.setFont(font);
//		xLabel.setText(Constant.DRAWPANEL_XLABEL);
//		xLabel.setAlignment(Label.CENTER);
//
//		yLabel=new Label();
//		yLabel.setForeground(foreground);
//		yLabel.setBackground(background);
//		yLabel.setFont(font);
//		yLabel.setText(Constant.DRAWPANEL_YLABEL);
//		yLabel.setAlignment(Label.CENTER);
//		
//		zLabel=new Label();
//		zLabel.setForeground(foreground);
//		zLabel.setBackground(background);
//		zLabel.setFont(font);
//		zLabel.setText(Constant.DRAWPANEL_ZLABEL);
//		zLabel.setAlignment(Label.CENTER);
//
//		xValue=new Label();
//		xValue.setForeground(foreground);
//		xValue.setBackground(background);
//		xValue.setFont(font);
//		xValue.setText(Double.toString(Constant.DRAWPANEL_XVALUE));
//		xValue.setAlignment(Label.CENTER);
//
//		yValue=new Label();
//		yValue.setForeground(foreground);
//		yValue.setBackground(background);
//		yValue.setFont(font);
//		yValue.setText(Double.toString(Constant.DRAWPANEL_YVALUE));
//		yValue.setAlignment(Label.CENTER);
//		
//		zValue=new Label();
//		zValue.setForeground(foreground);
//		zValue.setBackground(background);
//		zValue.setFont(font);
//		zValue.setText(Double.toString(Constant.DRAWPANEL_ZVALUE));
//		zValue.setAlignment(Label.CENTER);
//				
//		leftPanel=new Panel();
//		leftPanel.setLayout(new GridLayout(6,1));
//		leftPanel.add(xLabel);
//		leftPanel.add(xValue);
//		leftPanel.add(yLabel);
//		leftPanel.add(yValue);
//		leftPanel.add(zLabel);
//		leftPanel.add(zValue);
		
//		objectLabel=new Label();
//		objectLabel.setForeground(foreground);
//		objectLabel.setBackground(background);
//		objectLabel.setFont(font);
//		objectLabel.setText(Constant.DRAWPANEL_XLABEL);
//		objectLabel.setAlignment(Label.CENTER);
//		
//		scaleLabel=new Label();
//		scaleLabel.setForeground(foreground);
//		scaleLabel.setBackground(background);
//		scaleLabel.setFont(font);
//		scaleLabel.setText(Constant.DRAWPANEL_XLABEL);
//		scaleLabel.setAlignment(Label.CENTER);		
//		
//		rotateLabel=new Label();
//		rotateLabel.setForeground(foreground);
//		rotateLabel.setBackground(background);
//		rotateLabel.setFont(font);
//		rotateLabel.setText(Constant.DRAWPANEL_XLABEL);
//		rotateLabel.setAlignment(Label.CENTER);
//
//		translateLabel=new Label();
//		translateLabel.setForeground(foreground);
//		translateLabel.setBackground(background);
//		translateLabel.setFont(font);
//		translateLabel.setText(Constant.DRAWPANEL_XLABEL);
//		translateLabel.setAlignment(Label.CENTER);
		

		srtCheckboxGroup=new CheckboxGroup();
		sCheckbox=new Checkbox(Constant.DRAWPANEL_SCALE,srtCheckboxGroup,true);
		rCheckbox=new Checkbox(Constant.DRAWPANEL_ROTATE,srtCheckboxGroup,true);
		tCheckbox=new Checkbox(Constant.DRAWPANEL_TRANSLATE,srtCheckboxGroup,true);

		voCheckboxGroup=new CheckboxGroup();
		vertexCheckbox=new Checkbox(Constant.DRAWPANEL_BYVERTEX,voCheckboxGroup,false);
		objectCheckbox=new Checkbox(Constant.DRAWPANEL_BYOBJECT,voCheckboxGroup,true);
		weightsCheckbox=new Checkbox(Constant.DRAWPANEL_BYWEIGHT,voCheckboxGroup,false);

		vertexCheckbox.addItemListener(drawListener);
		objectCheckbox.addItemListener(drawListener);
		weightsCheckbox.addItemListener(drawListener);
		
		hullCheckbox=new Checkbox(Constant.DRAWPANEL_DRAWHULL);
		hullCheckbox.addItemListener(drawListener);
				
		selectionLabel=new Label();
//		selectionLabel.setForeground(foreground);
//		selectionLabel.setBackground(background);
//		selectionLabel.setFont(font);
		selectionLabel.setText(Constant.DRAWPANEL_SELECT);
		selectionLabel.setAlignment(Label.CENTER);

		modifyLabel=new Label();
//		modifyLabel.setForeground(foreground);
//		modifyLabel.setBackground(background);
//		modifyLabel.setFont(font);
		modifyLabel.setText(Constant.DRAWPANEL_MODIFY);
		modifyLabel.setAlignment(Label.CENTER);
						
		optionLabel=new Label();
//		optionLabel.setForeground(foreground);
//		optionLabel.setBackground(background);
//		optionLabel.setFont(font);
		optionLabel.setText(Constant.DRAWPANEL_OPTION);
		optionLabel.setAlignment(Label.CENTER);
		
		rightPanel=new Panel();
		rightPanel.setLayout(new GridLayout(6,3));
		rightPanel.add(new Label());
		rightPanel.add(modifyLabel);
		rightPanel.add(new Label());
		rightPanel.add(tCheckbox);
		rightPanel.add(rCheckbox);
		rightPanel.add(sCheckbox);
		rightPanel.add(new Label());
		rightPanel.add(selectionLabel);
		rightPanel.add(new Label());
		rightPanel.add(objectCheckbox);
		rightPanel.add(vertexCheckbox);
		rightPanel.add(weightsCheckbox);
		rightPanel.add(new Label());
		rightPanel.add(optionLabel);
		rightPanel.add(new Label());
		rightPanel.add(hullCheckbox);
						
		centralPanel.add(topCanvas);
		centralPanel.add(eyeCanvas);
		centralPanel.add(sideCanvas);
		centralPanel.add(frontCanvas);
		
		
		create=new Button(Constant.DRAWPANEL_CREATE);
		create.addActionListener(drawListener);
		
		delete=new Button(Constant.DRAWPANEL_DELETE);	
		delete.addActionListener(drawListener);
		
		check=new Button(Constant.DRAWPANEL_CHECK);	
		check.addActionListener(drawListener);
		
		buttonPanel=new Panel();
		buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER));

		objectChoice=new Choice();
		objectChoice.add(Constant.DRAWPANEL_CUBE);
		objectChoice.add(Constant.DRAWPANEL_SPHERE);
		objectChoice.add(Constant.DRAWPANEL_BERZIE);
		objectChoice.add(Constant.DRAWPANEL_RATIONALBERZIE);
		objectChoice.setForeground(foreground);
		objectChoice.setBackground(background);
		objectChoice.setFont(font);

		checkChoice=new Choice();
		checkChoice.add(Constant.DRAWPANEL_CHECKSPHERE);
		checkChoice.add(Constant.DRAWPANEL_CHECKCUBE);
		checkChoice.add(Constant.DRAWPANEL_CHECKANALITYC);
		checkChoice.setForeground(foreground);
		checkChoice.setBackground(background);
		checkChoice.setFont(font);

		
		buttonPanel.add(objectChoice);
		buttonPanel.add(create);
		buttonPanel.add(delete);
		buttonPanel.add(check);
		buttonPanel.add(checkChoice);
		
		this.setLayout(new BorderLayout());
//		this.add(leftPanel,BorderLayout.WEST);
		this.add(centralPanel,BorderLayout.CENTER);
		this.add(rightPanel,BorderLayout.EAST);
		this.add(buttonPanel,BorderLayout.SOUTH);
	}
	
	public void reDraw() {
		
		this.frontCanvas.repaint();
		this.sideCanvas.repaint();
		this.eyeCanvas.repaint();
		this.topCanvas.repaint();
	}
}