import java.lang.Math;

public class DrawSphere extends Draw {


	public DrawSphere() {
	double[] point=new double[4];
	int[] neighbour;

		point[0]=0;
		point[1]=0;
		point[2]=CoreConstant.DRAWSPHERE_RADIUS;	
		point[3]=1.0;
		neighbour=new int[CoreConstant.DRAWSPHERE_SECTIONS];
		for(int i=0;i<CoreConstant.DRAWSPHERE_SECTIONS;i++)
			neighbour[i]=i+1;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		neighbour=new int[4];
		for(int i=1;i<CoreConstant.DRAWSPHERE_HEIGHTCIRCLES-1;i++)
			for(int j=0;j<CoreConstant.DRAWSPHERE_SECTIONS;j++) {
				double tmp;
				tmp=Math.cos(Math.PI/2-(Math.PI*(double)i/(double)(CoreConstant.DRAWSPHERE_HEIGHTCIRCLES-1)))*CoreConstant.DRAWSPHERE_RADIUS;;

				point[2]=Math.sin(Math.PI/2-(Math.PI*(double)i/(double)(CoreConstant.DRAWSPHERE_HEIGHTCIRCLES-1)))*CoreConstant.DRAWSPHERE_RADIUS;
				point[0]=Math.cos(2*Math.PI*((double)j/(double)CoreConstant.DRAWSPHERE_SECTIONS))*Math.abs(tmp);
				point[1]=Math.sin(2*Math.PI*((double)j/(double)CoreConstant.DRAWSPHERE_SECTIONS))*Math.abs(tmp);
				point[3]=1.0;

				if(i==1)
					neighbour[0]=0;
				else
					neighbour[0]=1+(i-2)*CoreConstant.DRAWSPHERE_SECTIONS+j;
					neighbour[1]=1+(i-1)*CoreConstant.DRAWSPHERE_SECTIONS+(j+1)%(CoreConstant.DRAWSPHERE_SECTIONS);
					neighbour[2]=1+(i-1)*CoreConstant.DRAWSPHERE_SECTIONS+(j+CoreConstant.DRAWSPHERE_SECTIONS-1)%(CoreConstant.DRAWSPHERE_SECTIONS);
				
				//	neighbour[2]=((j+1)%CoreConstant.DRAWSPHERE_SECTIONS+1)+(i-1)*CoreConstant.DRAWSPHERE_SECTIONS;
				//	neighbour[1]=((j-1)%CoreConstant.DRAWSPHERE_SECTIONS+1)+(i-1)*CoreConstant.DRAWSPHERE_SECTIONS;
				if(i==CoreConstant.DRAWSPHERE_HEIGHTCIRCLES-2)
					neighbour[3]=(CoreConstant.DRAWSPHERE_HEIGHTCIRCLES-2)*CoreConstant.DRAWSPHERE_SECTIONS+1;
				else
					neighbour[3]=1+i*CoreConstant.DRAWSPHERE_SECTIONS+j;
//				for(int k=0;k<neighbour.length;k++)
//					System.out.println("i: " + i + " j: "+ j +" neigh["+k+"]: "+neighbour[k]);
//				System.out.println();
//				for(int k=0;k<4;k++)
//					System.out.println("i: " + i + " j: "+ j +" point["+k+"]: "+point[k]+ " tmp: " +tmp);
//				System.out.println();
//				System.out.println();
				vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));			
			}
		point[0]=0;
		point[1]=0;
		point[2]=-CoreConstant.DRAWSPHERE_RADIUS;	
		point[3]=1.0;
		neighbour=new int[CoreConstant.DRAWSPHERE_SECTIONS];
		for(int i=0;i<CoreConstant.DRAWSPHERE_SECTIONS;i++)
			neighbour[i]=i+1+CoreConstant.DRAWSPHERE_SECTIONS*(CoreConstant.DRAWSPHERE_HEIGHTCIRCLES-3);
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));	
		setColor(CoreConstant.DRAWSPHERE_COLOR);
	}

	public DrawSphere(double radius,int sections,int heightcircles) {
	double[] point=new double[4];
	int[] neighbour;

		point[0]=0;
		point[1]=0;
		point[2]=radius;	
		point[3]=1.0;
		neighbour=new int[sections];
		for(int i=0;i<sections;i++)
			neighbour[i]=i+1;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		neighbour=new int[4];
		for(int i=1;i<heightcircles-1;i++)
			for(int j=0;j<sections;j++) {
				double tmp;
				tmp=Math.cos(Math.PI/2-(Math.PI*(double)i/(double)(heightcircles-1)))*radius;;

				point[2]=Math.sin(Math.PI/2-(Math.PI*(double)i/(double)(heightcircles-1)))*radius;
				point[0]=Math.cos(2*Math.PI*((double)j/(double)sections))*Math.abs(tmp);
				point[1]=Math.sin(2*Math.PI*((double)j/(double)sections))*Math.abs(tmp);
				point[3]=1.0;

				if(i==1)
					neighbour[0]=0;
				else
					neighbour[0]=1+(i-2)*sections+j;
					neighbour[1]=1+(i-1)*sections+(j+1)%(sections);
					neighbour[2]=1+(i-1)*sections+(j+sections-1)%(sections);
				
				//	neighbour[2]=((j+1)%sections+1)+(i-1)*sections;
				//	neighbour[1]=((j-1)%sections+1)+(i-1)*sections;
				if(i==heightcircles-2)
					neighbour[3]=(heightcircles-2)*sections+1;
				else
					neighbour[3]=1+i*sections+j;
//				for(int k=0;k<neighbour.length;k++)
//					System.out.println("i: " + i + " j: "+ j +" neigh["+k+"]: "+neighbour[k]);
//				System.out.println();
//				for(int k=0;k<4;k++)
//					System.out.println("i: " + i + " j: "+ j +" point["+k+"]: "+point[k]+ " tmp: " +tmp);
//				System.out.println();
//				System.out.println();
				vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));			
			}
		point[0]=0;
		point[1]=0;
		point[2]=-radius;	
		point[3]=1.0;
		neighbour=new int[sections];
		for(int i=0;i<sections;i++)
			neighbour[i]=i+1+sections*(heightcircles-3);
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));	
		setColor(CoreConstant.DRAWSPHERE_COLOR);
	}
}