import java.util.Vector;
import java.awt.Color;

public class Engine {


	static double[] camera,origin;
	static double[] uv;
	static double distance,sideDistance,topDistance,frontDistance;
	static Vector draw=new Vector(CoreConstant.ENGINE_INITCAP,CoreConstant.ENGINE_INCR);
	static double[] translate;
	static int drawType;
	static double[] rotation,scale;
	static Color oldColor;
	static int selected=-1,selectedVertex=-1,selectedWeight=-1;

	Engine() {
	}
	
	public static Vector Pipeline(int type) {

	Draw element,returnElement;
	Vector returnValue;
	double[] vertex;
	
		returnValue=new Vector(CoreConstant.ENGINE_INITCAP,CoreConstant.ENGINE_INCR);
		setWorld(type);
		for(int i=0;i<draw.size();i++) {
			element=(Draw)draw.get(i);
			if(element.getType()==CoreConstant.DRAWCANVAS_POLY)
				returnElement=new Draw();
			else if (element.getType()==CoreConstant.DRAWCANVAS_BERZIE) 
				returnElement=new DrawBerzie(element.getDegreeX(),element.getDegreeY(),0);
			else if(element.getType()==CoreConstant.DRAWCANVAS_RATIONAL) {
				returnElement=new DrawRationalBerzie(element.getDegreeX(),element.getDegreeY(),0);				
				returnElement.setWeights(element.getWeights());
			}
			else
				returnElement=null;
			

//			System.out.println(draw.size()+"\n");
			returnElement.setColor(element.getColor());
//			returnElement.setType(element.getType());
			setRotation(element.getRotate());
			setTranslate(element.getTranslate());
			setScale(element.getScale());
			Geometry.clear();
			if(getScale()!=null)
				Geometry.scale(getScale());
			if(getRotation()!=null)
				Geometry.rotate(getRotation());
			if(getTranslate()!=null)
				Geometry.translate(getTranslate());
			Geometry.setGeometry();
			Geometry.concatenate();
//			if(type==CoreConstant.ENGINE_EYE)
//				if(!isInFOV(element))
//					element=clip(element);
			for(int j=0;j<element.size();j++) {
				vertex=element.getVertex(j);
//				Geometry.CheckClip(vertex,type);
//				System.out.println("\n0: "+vertex[0]+"1: "+vertex[1]+ "2: "+vertex[2]+ "3: " + vertex[3]);
				vertex=Elaborate(CoreConstant.DRAWCANVAS_NOFLYP,vertex);
//				System.out.println("\nafter0: "+vertex[0]+"1: "+vertex[1]+ "2: "+vertex[2]);
				returnElement.addElement((double[])vertex.clone(),element.getNeighbours(j),((String)element.getName(j)));		
			}
			returnValue.add(returnElement);
//			System.out.println("-------------------------------");
		}
		return returnValue;
	}
	
	private static void setWorld(int type) {
	
		if (type==CoreConstant.ENGINE_EYE) {
			Geometry.clear();
			Geometry.eyePerspective(camera,distance);
			Geometry.eyeImage(uv);
			Geometry.setWorld();
		}else if (type==CoreConstant.ENGINE_TOP) {
			Geometry.clear();
			Geometry.topPerspective(topDistance);
			Geometry.topImage(uv);
			Geometry.setWorld();
		}else if (type==CoreConstant.ENGINE_SIDE) {
			Geometry.clear();
			Geometry.sidePerspective(sideDistance);
			Geometry.sideImage(uv);
			Geometry.setWorld();
		}else if (type==CoreConstant.ENGINE_FRONT) {
			Geometry.clear();
			Geometry.frontPerspective(frontDistance);
			Geometry.frontImage(uv);
			Geometry.setWorld();
		}
	}
	  
	public static double[] Elaborate(int drawType,double[] vertex) {
	
		for(int i=0;i<draw.size();i++)  {
			if (drawType==CoreConstant.DRAWCANVAS_NOFLYP) {
				return(Geometry.applyTransform(vertex));			
			}else
			if (drawType==CoreConstant.DRAWCANVAS_RTSTYPE) {
				Geometry.clear();
				Geometry.rotate(rotation);
				Geometry.translate(translate);
				Geometry.scale(scale);
				Geometry.eyePerspective(camera,distance);
				Geometry.eyeImage(uv);
				return(Geometry.applyTransform(vertex));			
			}else
			if (drawType==CoreConstant.DRAWCANVAS_TRSTYPE) {
				Geometry.clear();			
				Geometry.translate(translate);
				Geometry.rotate(rotation);
				Geometry.scale(scale);
				Geometry.eyePerspective(camera,distance);
				Geometry.eyeImage(uv);
				return(Geometry.applyTransform(vertex));			
			}else
			if (drawType==CoreConstant.DRAWCANVAS_STRTYPE) {
				Geometry.clear();			
				Geometry.scale(scale);
				Geometry.translate(translate);
				Geometry.rotate(rotation);
				Geometry.eyePerspective(camera,distance);
				Geometry.eyeImage(uv);
				return(Geometry.applyTransform(vertex));			
			}else			
			if (drawType==CoreConstant.DRAWCANVAS_RTTYPE) {
				Geometry.clear();
				Geometry.rotate(rotation);
				Geometry.translate(translate);
				Geometry.eyePerspective(camera,distance);
				Geometry.eyeImage(uv);
				return(Geometry.applyTransform(vertex));			
			}else
			if (drawType==CoreConstant.DRAWCANVAS_TRTYPE) {
				Geometry.clear();
				Geometry.translate(translate);
				Geometry.rotate(rotation);
				Geometry.eyePerspective(camera,distance);
				Geometry.eyeImage(uv);
				return(Geometry.applyTransform(vertex));						
			}else			
			if (drawType==CoreConstant.DRAWCANVAS_TTYPE) {
				Geometry.clear();
				Geometry.translate(translate);
				Geometry.eyePerspective(camera,distance);
				Geometry.eyeImage(uv);
				return(Geometry.applyTransform(vertex));			
			}else
			if (drawType==CoreConstant.DRAWCANVAS_RTYPE) {
				Geometry.clear();
				Geometry.rotate(rotation);
				Geometry.eyePerspective(camera,distance);
				Geometry.eyeImage(uv);
				return(Geometry.applyTransform(vertex));						
			}
		}
		return null;
	}
	
	public static void addDraw(Draw add) {

//		Engine.removeNotReal();
		draw.add(add);
	}
	
	public static void setEye(double[] point) {
	
		camera=point;
	}
	
	public static void setDistance(double distance) {
//	
		if (distance<camera[0]-CoreConstant.DRAWCANVAS_CAMERADIST && distance>CoreConstant.DRAWCANVAS_MINDIST) {
			Engine.distance=distance;
		}
	}

	public static double getDistance() {
	
		return distance;
	}

	public static void setFrontDistance(double distance) {
	
		if(distance>=CoreConstant.DRAWCANVAS_MINDIST && distance<=CoreConstant.DRAWCANVAS_MAXDISTANCE)
			Engine.frontDistance=distance;
	}

	public static double getFrontDistance() {
	
		return frontDistance;
	}

	public static void setTopDistance(double distance) {
	
			if(distance>=CoreConstant.DRAWCANVAS_MINDIST && distance<=CoreConstant.DRAWCANVAS_MAXDISTANCE)
				Engine.topDistance=distance;
	}

	public static double getTopDistance() {
	
		return topDistance;
	}
	
	public static void setSideDistance(double distance) {
	
			if(distance>=CoreConstant.DRAWCANVAS_MINDIST && distance<=CoreConstant.DRAWCANVAS_MAXDISTANCE)
				Engine.sideDistance=distance;
	}

	public static double getSideDistance() {
	
		return sideDistance;
	}
	public static double[] getEye() {
	
		return camera;
	}
	
	public static void setRotation(double[] rotation) {
	
		Engine.rotation=rotation;
	}
	
	
	public static double[] getRotation() {
	
		return rotation;
	}
	
	public static double[] getTranslate() {	

		return translate;
	}

	public static void setTranslate(double[] translate) {
	
		if (true) {
			Engine.translate=translate;
		
		}
	}
	
	public static double[] getScale() {	

		return scale;
	}

	public static void setScale(double[] scale) {
	
		if (true) {
			Engine.scale=scale;
		
		}
	}
	public static void setDrawType(int drawType) {
	
		if (true) {
			Engine.drawType=drawType;
		
		}
	}
	
	public static int getDrawType() {
	
		return drawType;
	
	}
	
	public static void setUV(double[] uv) {
	
		if (true) {
			Engine.uv=uv;
		
		}
	}
	
	public static double[] getUV() {
	
		return uv;
	
	}
	
	public static void setDrawTranslate(double[] translate) {
	
		if(selected!=-1)
			((Draw)draw.get(selected)).setTranslate(translate);
//		Engine.removeNotReal();
	}
	
	public static double[] getDrawTranslate() {
	
		if (selected!=-1)
			return (((Draw)draw.get(selected)).getTranslate());
		return(null);
	}
	
	public static void setDrawRotate(double[] rotate) {
	
		if(selected!=-1)
			((Draw)draw.get(selected)).setRotate(rotate);
//		Engine.removeNotReal();	
	}
	
	public static double[] getDrawRotate() {
	
		if (selected!=-1)
			return (((Draw)draw.get(selected)).getRotate());
		return(null);
	}
	
	public static void setDrawScale(double[] scale) {
	
		if(selected!=-1)
			((Draw)draw.get(selected)).setScale(scale);
//		Engine.removeNotReal();
	}
	
	public static double[] getDrawScale() {
	
		if (selected!=-1)
			return (((Draw)draw.get(selected)).getScale());
		return(null);
	}

	public static void select(int position) {
	
		if (selected>=draw.size())
			selected=-1;
		else
		if (position!=-1) {
			if (selected!=-1)
				((Draw)draw.get(selected)).setColor(oldColor);
			selected=position;
			oldColor=((Draw)draw.get(position)).getColor();
			((Draw)draw.get(position)).setColor(CoreConstant.ENGINE_SELECTEDCOLOR);
		}else if (selected!=-1) {
			((Draw)draw.get(selected)).setColor(oldColor);
			selected=-1;
		}
	}

	public static void selectVertex(int position) {
	
		if (position!=-1) {
			selectedVertex=position;
		}else if (selectedVertex!=-1) {
			selectedVertex=-1;
		}
	}

	public static void setSelectedWeight(int position) {

		if (position!=-1) {
			selectedWeight=position;
		}else if (selectedWeight!=-1) {
			selectedWeight=-1;
		}	
	}
	
	public static void setWeight(double value) {
	
//		System.out.println("sel: "+selected +" weight: "+selectedWeight);
		if (selected!=-1 && selectedWeight!=-1)
			((DrawRationalBerzie)draw.get(selected)).setWeight(selectedWeight,value);
		Engine.removeNotReal();
	}
	
	public static void setSelectedVertex(double[] point) {
	
//		for(int i=0;i<point.length;i++)
//			System.out.println("point " +point[i]);
		if (selected!=-1 && selectedVertex!=-1)
			((Draw)draw.get(selected)).setVertex(selectedVertex,point);
	}
	
	public static double[] getSelectedVertex() {
	
		if (selected!=-1 && selectedVertex!=-1)
			return(((Draw)draw.get(selected)).getVertex(selectedVertex));
		return null;
	}
	
	public static double getWeight() {
	
		if (selected!=-1 && selectedWeight!=-1)
			return(((DrawRationalBerzie)draw.get(selected)).getWeight(selectedWeight));  //Prob unificabile selected Vertex(propieta dell'oggetto?
		return Double.NaN;
	}
	
	public static void removeSelected() {
	
		if (selected!=-1) {
			draw.remove(selected);
			selected=-1;
		}
	}
	
	public static void setColor(Color color) {

		if (selected!=-1) {
			oldColor=color;			
		}

	}
	
//	public static boolean isInFOV(Draw draw) {
//		
//	double[] tmpVertex,imagePlane;
//	double value;
//		
//		imagePlane=Geometry.getImagePlane();
//		for(int i=0;i<draw.size();i++) {
//			tmpVertex=draw.getVertex(i);
//			value=0;
//			for(int j=0;j<tmpVertex.length-1;j++)
//				value+=tmpVertex[j]*imagePlane[j];
//			value+=imagePlane[imagePlane.length-1];
//			if(value<0)
//				return false;	
//		}
//		return true;
//	}
	
//	public static Draw clip(Draw draw) {
	
//	double[] tmpVertex,imagePlane,p1,p2;
//	double value;
//	int[] clipping=new int[draw.size()];
//	int[] neighbour,tmpNeighbour;
//	int count=0;
//	boolean flag,usable;
//	
//		
//		imagePlane=Geometry.getImagePlane();
//		for(int i=0;i<draw.size();i++) {
//			tmpVertex=draw.getVertex(i);
//			value=0;
//			for(int j=0;j<tmpVertex.length-1;j++)
//				value+=tmpVertex[j]*imagePlane[j];
//			value+=imagePlane[imagePlane.length-1];
//			if(value<0) 
//				clipping[count]=i;
//		}
//		for(int i=0;-1!=clipping[i] && i<clipping.length;i++) {
//			neighbour=draw.getNeighbours(clipping[i]);
//			p1=draw.getVertex(clipping[i]);
//			usable=true;
//			flag=true;
//			for(int j=0;j<neighbour.length;j++) {
//				for(int k=0;-1!=clipping[k] && k<clipping.length;k++)
//					if(neighbour[j]==clipping[k])
//						flag=false;
//					if(flag)
//						if(usable) {
//							p2=draw.getVertex(neighbour[j]);
//							tmpVertex=Geometry.clip(p1,p2);
//							tmpNeighbour=new int[1];
//							tmpNeighbour[0]=neighbour[j];
//							draw.setVertex(clipping[i],tmpVertex,tmpNeighbour.clone());
//							usable=false;
//						}else {
//							p2=draw.getVertex(neighbour[j]);
//							tmpVertex=Geometry.clip(p1,p2);
//							tmpNeighbour=new int[1];
//							tmpNeighbour[0]=neighbour[j];
//							draw.addElement(tmpVertex,(int[])tmpNeighbour.clone());
//							tmpNeighbour=draw.getNeighbours(neighbour[j]);
//							for(int m=0;m<tmpNeighbour.length;m++)
//								if(tmpNeighbour[m]==clipping[i])
//									tmpNeighbour[m]=draw.size()+count;
//							count++;
//						}
//			}
//		}
//		return draw;
	
//		double[] imagePlane,tmpVertex;
//		double value;
//		int[] clipping=new int[draw.size()];
//		int count=0;
//		Draw returnValue;
//		
//		returnValue=new Draw()
//		imagePlane=Geometry.getImagePlane();
//		for(int i=0;i<draw.size();i++) {
//			tmpVertex=draw.getVertex(i);
//			value=0;
//			for(int j=0;j<tmpVertex.length-1;j++)
//				value+=tmpVertex[j]*imagePlane[j];
//			value+=imagePlane[imagePlane.length-1];
//			if(value<0) {
//				clipping[count]=i;
//				count++;
//			}
//		}
//		
//	
//	
//	
//	
//	
//	}
	public static void checkCollision() {
	Draw tmp,draw1,draw2;
	int size;
	
		size=draw.size();
		for(int i=CoreConstant.DRAWCANVAS_MAXRESERVED;i<size;i++)
			for(int j=i+1;j<size;j++) {
				draw1=(Draw)draw.get(i);
				draw2=(Draw)draw.get(j);
				if(draw1.isReal && draw2.isReal){
					tmp=CollisionEngine.check(draw1,draw2);
					if(tmp!=null) {
						Engine.addDraw(tmp);
	//					System.out.println("icici " +draw.size());
					}
				}
			}
	}
	
	public static void removeNotReal(){
		
		for(int i=0;i<draw.size();i++)
			if(!((Draw)draw.get(i)).isReal)
				draw.remove(i);
	}
	
	public static void flush(){
	
		selected=-1;
		selectedVertex=-1;
		selectedWeight=-1;
		draw=new Vector(CoreConstant.ENGINE_INITCAP,CoreConstant.ENGINE_INCR);
	}

}